      processor 6502
;Default 2600 Constants set up by dissasembler..
VSYNC   =  $00
VBLANK  =  $01
WSYNC   =  $02
RSYNC   =  $03
NUSIZ0  =  $04
NUSIZ1  =  $05
COLUP0  =  $06
COLUP1  =  $07
COLUPF  =  $08
COLUBK  =  $09
CTRLPF  =  $0A
PF0     =  $0D
PF1     =  $0E
PF2     =  $0F
RESP0   =  $10
AUDC0   =  $15
AUDC1   =  $16
AUDF0   =  $17
AUDF1   =  $18
AUDV0   =  $19
AUDV1   =  $1A
GRP0    =  $1B
GRP1    =  $1C
ENAM0   =  $1D
ENAM1   =  $1E
ENABL   =  $1F
HMP0    =  $20
VDELP1  =  $26
HMOVE   =  $2A
HMCLR   =  $2B
CXCLR   =  $2C
CXP0FB  =  $32
CXP1FB  =  $33
CXM0FB  =  $34
CXM1FB  =  $35
CXBLPF  =  $36
CXPPMM  =  $37
INPT4   =  $3C
SWCHA   =  $0280
SWCHB   =  $0282
INTIM   =  $0284
TIM64T  =  $0296


;variables...
RoomLo        =  $80
RoomHi        =  $81
Obj1Lo        =  $82
Obj1Hi        =  $83
Obj2Lo        =  $84
Obj2Hi        =  $85
Obj1X         =  $86
Obj1Y         =  $87
Obj2X         =  $88
Obj2Y         =  $89
PlayerRoom    =  $8A
PlayerX       =  $8B
PlayerY       =  $8C
PlayerYadj    =  $8D
ScanLineCnt   =  $8E
RoomDefIndex  =  $8F
Player0Def    =  $90
Player1Def    =  $91
Debounce      =  $92
CurrentObject =  $93 ;(5 bytes)
Jstick        =  $98
CurrentStick  =  $99
ObjAddress    =  $9A
ObjDir        =  $9B
LastObj       =  $9C
CarriedObj    =  $9D
CarriedX      =  $9E
CarriedY      =  $9F
HiCnt         =  $A0
ObjLst        =  $A1 ;(2 bytes)
Delta2        =  $A3
Delta1        =  $A4
ObjCr         =  $A5
State         =  $A6
Level         =  $A7
Control       =  $A8
NoteCnt       =  $A9
Sound         =  $AA
Index         =  $AB
PrevRoom      =  $AC
PrevX         =  $AD
PrevY         =  $AE
LoCnt         =  $AF
ObjectNumber  =  $B0


;object variables...
SurroundR     =  $B1 ;(3 bytes)
DotR          =  $B4 ;(3 bytes)

;all dragons must be consecutive
RDragonR      =  $B7 ;(5 bytes)
YDragonR      =  $BC ;(5 bytes)
GDragonR      =  $C1 ;(5 bytes)

MagnetR       =  $C6 ;(3 bytes)
SwordR        =  $C9 ;(3 bytes)
ChaliseR      =  $CC ;(3 bytes)
BridgeR       =  $CF ;(3 bytes)

;all keys must be consecutive
YKeyR         =  $D2 ;(3 bytes)
WKeyR         =  $D5 ;(3 bytes)
BKeyR         =  $D8 ;(3 bytes)

;all gates must be consecutive
YGateR        =  $DB
WGateR        =  $DC
BGateR        =  $DD

BatR          =  $DE ;(7 bytes)



;------------------------------------------------------------------------------------
;Ram locations E5-FA free (F9/FA -might- be used by the stack if JSR's nested further)
;------------------------------------------------------------------------------------




Temp          =  Player0Def ;(shared)
NullR         =  BridgeR    ;(all shared)




;constants...

;Object numbers:
;these are used to calculate the offsets of the object table
SurroundNumber =  SurroundData - Objects ;($00)
YGateNumber    =  YGateData - Objects    ;($08)
WGateNumber    =  WGateData - Objects    ;($10)
BGateNumber    =  BGateData - Objects    ;($18)
AuthorNumber   =  AuthorData - Objects   ;($20)
NumberNumber   =  NumberData - Objects   ;($28)
RDragonNumber  =  RDragonData - Objects  ;($30)
YDragonNumber  =  YDragonData - Objects  ;($38)
GDragonNumber  =  GDragonData - Objects  ;($40)
SwordNumber    =  SwordData - Objects    ;($48)
BridgeNumber   =  BridgeData - Objects   ;($50)
YKeyNumber     =  YKeyData - Objects     ;($58)
WKeyNumber     =  WKeyData - Objects     ;($60)
BKeyNumber     =  BKeyData - Objects     ;($68)
BatNumber      =  BatData - Objects      ;($70)
DotNumber      =  DotData - Objects      ;($78)
ChaliseNumber  =  ChaliseData - Objects  ;($80)
MagnetNumber   =  MagnetData - Objects   ;($88)
NullNumber     =  NullData - Objects     ;($90)

;RD0 used to calculate map direction value when including differences
RD0            =  RoomDiffs - $80

WinRoom        =  $12 ;(Yellow Castle's room number)
ByteNum        =  Game2Objects - (Game1Objects+1) ;number of bytes in each "fill" table
RndNum         =  Loc_4 - (Loc_1 + 3) ; offset value for the room bounds table
RndMax         =  $1F ;Mask for the upper bounds of the random seed
Gates          =  $02 ;# of castle gates - 1


       ORG $F000


PrintDisplay:
;Print Display
       STA    HMCLR               ;Clear horzontal motion.                               ;3
       LDA    Obj1X               ;Position Player00 Sprite To                           ;3
       LDX    #$00                ;      the X Coordinate of Object1.                    ;2
       JSR    PosSpriteX           ;6
       LDA    Obj2X               ;Position Player01 Sprite to                           ;3
; the subroutine PosSpriteX doesn't change X, so an increment will do as well
       INX                                                                               ;2
       JSR    PosSpriteX                                                                 ;6
       LDA    PlayerX             ;Position Ball Strite to                               ;3
       LDX    #$04                ;      the X Coordinate of the Man.                    ;2
       JSR    PosSpriteX          ;                                                      ;6
       STA    WSYNC               ;Wait for horizontal Blank.                            ;3
       STA    HMOVE               ;Apply Horizontal Motion.                              ;3
       STA    CXCLR               ;Clear Collision Latches.                              ;3
       LDA    PlayerY             ;Get the Y Coordinate of the Man.                      ;3
       SEC                        ;                                                      ;2
       SBC    #$04                ;And Adjust it (By Four Scan Lines)                    ;2
       STA    PlayerYadj          ;      for printing (so Y Coordinate Specifies Middle) ;3
PrintDisplay_1:
; a. after the loop A is 0, so reloading is superflous
; b. replaced A with X so we can increment
; c. bugfix: the register is called VDEL*P*1
       LDX    INTIM               ;Wait for end of the                                   ;4
       BNE    PrintDisplay_1      ;      current fame.                                   ;2
       STX    Player0Def          ;Set Player00 definition index.                        ;3
       STX    Player1Def          ;Set Player01 definition index.                        ;3
       STX    RoomDefIndex        ;Set room definition index.                            ;3
       STX    GRP1                ;Clear any graphics for Player01.                      ;3
       INX                        ;                                                      ;2
       STX    VDELP1              ;vertically delay Player 01                            ;3
       LDA    #$68                ;                                                      ;2
       STA    ScanLineCnt         ;Set Scan Line Count.                                  ;3
;Print top line of Room.
       LDY    RoomDefIndex        ;Get room definition index.                            ;3
       LDA    (RoomLo),Y          ;Get first room definition byte.                       ;5
       STA    PF0                 ;      and display.                                    ;3
       INY                        ;                                                      ;2
       LDA    (RoomLo),Y          ;Get Next room definition byte.                        ;5
       STA    PF1                 ;      and display.                                    ;3
       INY                        ;                                                      ;2
       LDA    (RoomLo),Y          ;Get Last room defintion byte.                         ;5
       STA    PF2                 ;      and display.                                    ;3
       INY                        ;                                                      ;2
       STY    RoomDefIndex        ;Save for Next Time.                                   ;3
       STA    WSYNC               ;Wait for Horizontal Blank.                            ;3
; a. X still contains 1, so the important bit 1 for VBLANK is zero.
;    (this trick is also very common)
; b. a very usual trick: we know the state of a flag, so we replace JMP with a branch
;    (here Y always != 0 -> Z-flag = 0)
       STX    VBLANK              ;Clear any Vertical Blank.                             ;3
       BNE    PrintPlayer00       ;                                                      ;2
;Print Player01 (Object 02)
PrintPlayer01:
       LDA    ScanLineCnt         ;Get Current Scan Line.                                ;3
       SEC                        ;Have we reached Object2's                             ;2
       SBC    Obj2Y               ;      Y Coordinate?                                   ;3
       STA    WSYNC               ;      Wait for Horzonal Blank.                        ;3
       BPL    PrintPlayer00       ;If Not, Branch.                                       ;2
       LDY    Player1Def          ;Get the Player01 definition index.                    ;3
       LDA    (Obj2Lo),Y          ;Get the Next Player01 Definition byte                 ;5
       STA    GRP1                ;      and display.                                    ;3
       BEQ    PrintPlayer00       ;If Zero then Definition finished.                     ;2
       INC    Player1Def          ;Goto next Player01 definition byte.                   ;5
;Print Player00 (Object01), Ball (Man) and Room.
PrintPlayer00:
       LDX    #$00                ;                                                      ;2
       LDA    ScanLineCnt         ;Get the Current Scan Line.                            ;3
       SEC                        ;Have we reached the Object1's                         ;2
       SBC    Obj1Y               ;      Y coordinate?                                   ;3
       BPL    PrintPlayer00_1     ;If not then Branch.                                   ;2
       LDY    Player0Def          ;Get Player00 definition index.                        ;3
       LDA    (Obj1Lo),Y          ;Get the Next Player00 definition byte.                ;5
       TAX                        ;                                                      ;2
       BEQ    PrintPlayer00_1     ;If Zero then Definition finished.                     ;2
       INC    Player0Def          ;Go to Next Player00 definition byte.                  ;5
PrintPlayer00_1:
       LDY    #$00                ;Disable Ball Graphic.                                 ;2
       LDA    ScanLineCnt         ;Get Scan line count.                                  ;3
       SEC                        ;Have we reached the Man's                             ;2
       SBC    PlayerYadj          ;      Y Coordinate?                                   ;3
       AND    #$FC                ;Mask value to four either side (getting depth of 8)   ;2
       BNE    PrintPlayer00_2     ;If Not, Branch.                                       ;2
       LDY    #$02                ;Enable Ball Graphic.                                  ;2
PrintPlayer00_2:
       LDA    ScanLineCnt         ;Get Scan Line Count.                                  ;3


       AND    #$0F                ;Have we reached a sixteenth scan line?                ;2

;NOTE! The above line could be changed to 7 (checking every 8th scanline instead).  This will
;effectively DOUBLE the resolution for each screen. (you'll need to update the room GFX tables
;to have 42 bytes instead of 21).  The upper and lower lines of the higher res. bitmaps will
;just *barely* be visible...so by clever placement of the tags, this could be reduced to 36
;bytes per screen :)  Format of the updated line would be this:
;;       AND    #$07                ;Have we reached a eighth scan line?                   ;2
;...that will replace the above line and the program will grab new GFX values on every 8th line


       BNE    PrintPlayer00_4     ;If not, Branch.                                       ;2
       STA    WSYNC               ;Wait for Horzontal Blank.                             ;3
       STY    ENABL               ;Enable Ball (If Wanted)                               ;3
       STX    GRP0                ;Display Player 00 definition byte (if wanted)         ;3
       LDY    RoomDefIndex        ;Get room definition index.                            ;3
       LDA    (RoomLo),Y          ;Get first room definition byte,                       ;5
       STA    PF0                 ;      and display.                                    ;3
       INY                        ;                                                      ;2
       LDA    (RoomLo),Y          ;Get next room definition byte,                        ;5
       STA    PF1                 ;      and display.                                    ;3
       INY                        ;                                                      ;2
       LDA    (RoomLo),Y          ;Get next room definition byte,                        ;5
       STA    PF2                 ;      and display.                                    ;3
       INY                        ;                                                      ;2
       STY    RoomDefIndex        ;Save for Next Time.                                   ;3
PrintPlayer00_3:
       DEC    ScanLineCnt         ;Goto next scan line.                                  ;5
       LDA    ScanLineCnt         ;Get the scan line.                                    ;3
       CMP    #$08                ;Have we reached to within 8 scanlines of the bottom?  ;2
       BPL    PrintPlayer01       ;If not, Branch.                                       ;2
       STA    VBLANK              ;Turn on VBLANK                                        ;3
TidyUp:
       LDA    #$00                ;                                                      ;2
       STA    GRP1                ;Clear any graphics for Player01                       ;3
       STA    GRP0                ;Clear any graphics for Player00                       ;3
       LDA    #$20                ;                                                      ;2
       STA    TIM64T              ;Stat Timing this frame using                          ;4
PrintDisplayX:
       RTS                                                                               ;6

; a. by reordering the code, we avoid the jump to TidyUp
; b. again used the branch trick
PrintPlayer00_4:
       STA    WSYNC               ;Wait for Horzontal blank.                             ;3
       STY    ENABL               ;Enable Ball (If Wanted.)                              ;3
       STX    GRP0                ;Display Player00 definition byte (if Wanted).         ;3
       BNE    PrintPlayer00_3     ;                                                      ;2

;Position Sprite X horizontally.
PosSpriteX:
;Position Sprite X horizontally.
PoXsSprite:
       LDY    #$02                ;Start with 10 clock cycles (to avoid HBLANK)  ;2
       SEC                        ;Divide the Coordinate.                        ;2
PoXsSprite_1:
       INY                        ;      Wanted by Fifteen I.E.                  ;2
       SBC    #$0F                ;      Get Course Horizontal                   ;2
       BCS    PoXsSprite_1        ;      Value (In Multiples of 5 Clock Cycles   ;2
                                  ;      (Therefore giving 15 Color Cycles)
       EOR    #$FF                ;Flip remanter to positive value (inverted).   ;2
       SBC    #$06                ;Convert to left or right of current position. ;2
       ASL                        ;                                              ;2
       ASL                        ;Move to high nybble for TIA                   ;2
       ASL                        ;      horizontal motion.                      ;2
       ASL                        ;                                              ;2
       STY    WSYNC               ;Wait for horozontal blank.                    ;3
PoXsSprite_2:
       DEY                        ;Count down the color                          ;2
       BPL    PoXsSprite_2        ;cycles (these are 5 machine/15 color cycles). ;2
       STA    RESP0,X             ;Reset the sprite, thus positioning it coursely;4
       STA    HMP0,X              ;Set horizontal (fine) motion of sprite.       ;4
       RTS                        ;                                              ;6

;Preform VSYNC
DoVSYNC:
       LDX    INTIM               ;Get Timer Output                              ;4
       BNE    DoVSYNC             ;Wait for Time-Out                             ;2
       LDA    #$02                ;                                              ;2
       STA    WSYNC               ;Wait for horizonal blank.                     ;3
       STA    VBLANK              ;Start Vertical Blanking.                      ;3
       STA    WSYNC               ;Wait for horizonal blank.                     ;3
;       STA    WSYNC               ;Wait for horizonal blank.                     ;3
;       STA    WSYNC               ;Wait for horizonal blank.                     ;3
       STA    VSYNC               ;Start verticle sync.                          ;3
       STA    WSYNC               ;Wait for horizonal blank.                     ;3
       STA    WSYNC               ;Wait for horizonal blank.                     ;3
       STA    WSYNC               ;Wait for horizonal blank.                     ;3
       STX    VSYNC               ;End Vertical sync.                            ;3
;       LDA    #$2A                ;Set clock interval to                         ;2
       LDA    #$2C                ;Set clock interval to                         ;2
       STA    TIM64T              ;Countdown next frame.                         ;4
       RTS                        ;                                              ;6

;Setup a room for print.
SetupRoomPrint:
       LDA    PlayerRoom          ;Get current room number.                      ;3
       JSR    RoomNumToAddress    ;Convert it to an address.                     ;6
       LDY    #$00                ;                                              ;2
       LDA    (CurrentObject),Y   ;Get low pointer to room                       ;5
       STA    RoomLo              ;      Graphics                                ;3
       INY                        ;                                              ;2
       LDA    (CurrentObject),Y   ;Get high pointer to room                      ;5
       STA    RoomHi              ;      Graphics                                ;3
;Use Color
       INY                        ;                                              ;2
       LDA    (CurrentObject),Y   ;Get room color                                ;5
       JSR    ChangeColor         ;Change if necessary                           ;6
       STA    COLUPF              ;Put in Playfiled color register.              ;3
;Color Background.
UseColor:
       LDA    #$08                ;Get light grey background                     ;2
       JSR    ChangeColor         ;Change if necessary                           ;6
       STA    COLUBK              ;Put it in the Background color register.      ;3
;Playfield Control.
       LDY    #$03                ;                                              ;2
       LDA    (CurrentObject),Y   ;Get the playfield control value.              ;5
       STA    CTRLPF              ;And put in the playfield control register.    ;3
       LSR                        ;                                              ;2
       LSR                        ;                                              ;2
       LSR                        ;Get the first bit into position.              ;2
       LSR                        ;                                              ;2
       LSR                        ;                                              ;2
       STA    ENAM1               ;Enable right hand wall (if wanted-missile01)  ;3
       LSR                        ;                                              ;2
       STA    ENAM0               ;Enable left hand wall(if wanted-missle00)     ;3
;Get objects to display.
       JSR    CacheObjects        ;Get next two objects to display.              ;6
;Sort out their order.
       LDA    CurrentObject+2     ;If the object1 is the                         ;3
       BEQ    SwapPrintObjects    ;Then branch to swap (we want it as player01)  ;2
       CMP    #BridgeNumber       ;If the first object is the bridge then        ;2
       BNE    SetupObjectPrint    ;Swap the objects (we want it as player01)     ;2
       LDA    CurrentObject+3     ;If the object2 is the                         ;3
       BEQ    SetupObjectPrint    ;it (we want it as player01)                   ;2
SwapPrintObjects:
; using an unused register for swapping makes the code much shorter
       LDA    CurrentObject+2     ;                                              ;3
       LDX    CurrentObject+3     ;                                              ;3
       STA    CurrentObject+3     ;Swap the objects to print.                    ;3
       STX    CurrentObject+2     ;                                              ;3
;Setup Object1 to print.
SetupObjectPrint:
       LDX    CurrentObject+2     ;Get Object1                                   ;3
       LDA    Store1,X            ;Get low pointer to it's dynamic information.  ;4
       STA    CurrentObject       ;                                              ;3
       LDA    Store2,X            ;Get high pointer to it's dynamic informtion.  ;4
       STA    CurrentObject+1     ;                                              ;3
       LDY    #$01                ;                                              ;2
       LDA    (CurrentObject),Y   ;Get Object1's X coordinate                    ;5
       STA    Obj1X               ;and Store for print.                          ;3
       INY                        ;                                              ;2
       LDA    (CurrentObject),Y   ;Get Object1's Y coordinate                    ;5
       STA    Obj1Y               ;and Store for print.                          ;3
       LDA    Store3,X            ;Get low pointer to state value.               ;4
       STA    CurrentObject       ;                                              ;3
       LDA    Store4,X            ;Get high pointer to state value.              ;4
       STA    CurrentObject+1     ;                                              ;3
       LDY    #$00                ;                                              ;2
       LDA    (CurrentObject),Y   ;Retrieve Object1's current state.             ;5
       STA    State               ;                                              ;3
       LDA    Store5,X            ;Get low pointer to state information.         ;4
       STA    CurrentObject       ;                                              ;3
       LDA    Store6,X            ;Get high pointer to state information.        ;4
       STA    CurrentObject+1     ;                                              ;3
       JSR    GetObjectState      ;Find current state in the state information.  ;6
       INY                        ;Index to the state's corresponding graphic pointer;2
       LDA    (CurrentObject),Y   ;Get Object1's low graphic address             ;5
       STA    Obj1Lo              ;and store for print.                          ;3
       INY                        ;                                              ;2
       LDA    (CurrentObject),Y   ;Get Object1's high graphic address            ;5
       STA    Obj1Hi              ;and store for print.                          ;3
;Colour
       LDA    Store7,X            ;Get Object1's Color.                          ;4
       JSR    ChangeColor         ;Change if necessary.                          ;6
       STA    COLUP0              ;And set color luminance00.                    ;3
;Object1 Size
ResizeObject:
       LDA    Store8,X            ;Get Object1's Size                            ;4
       ORA    #$10                ;And set to larger size if necessary.          ;2
       STA    NUSIZ0              ;(Used by bridge and invisible surround)       ;3
;Setup Object 2 to Print.
       LDX    CurrentObject+3     ;Get Object 2                                  ;3
       LDA    Store1,X            ;                                              ;4
       STA    CurrentObject       ;Get low pointer to it's dynamic information.  ;3
       LDA    Store2,X            ;                                              ;4
       STA    CurrentObject+1     ;Get high pointer to it's dynamic information. ;3
       LDY    #$01                ;                                              ;2
       LDA    (CurrentObject),Y   ;Get Object2's X coordinate                    ;5
       STA    Obj2X               ;and store for print.                          ;3
       INY                        ;                                              ;2
       LDA    (CurrentObject),Y   ;Get Object2's Y coordinate                    ;5
       STA    Obj2Y               ;and store for print.                          ;3
       LDA    Store3,X            ;Get low pointer to state value.               ;4
       STA    CurrentObject       ;                                              ;3
       LDA    Store4,X            ;Get high pointer to state value.              ;4
       STA    CurrentObject+1     ;                                              ;3
       LDY    #$00                ;                                              ;2
       LDA    (CurrentObject),Y   ;Retrieve Object2's current state.             ;5
       STA    State               ;                                              ;3
       LDA    Store5,X            ;Get low pointer to state information.         ;4
       STA    CurrentObject       ;                                              ;3
       LDA    Store6,X            ;Get high pointer to state information.        ;4
       STA    CurrentObject+1     ;                                              ;3
       JSR    GetObjectState     ;Find the current state in the state information;6
       INY                       ;Index to state's corresponding graphic pointer ;2
       LDA    (CurrentObject),Y   ;                                              ;5
       STA    Obj2Lo              ;Get Object2's low graphic address.            ;3
       INY                        ;                                              ;2
       LDA    (CurrentObject),Y   ;Get Object2's high graphic address.           ;5
       STA    Obj2Hi              ;                                              ;3
;Color
       LDA    Store7,X            ;Get Object2's Color                           ;4
       JSR    ChangeColor         ;Change if Necessary.                          ;6
       STA    COLUP1              ;and set color luminance01.                    ;3
;Object2 Size
ResizeObject2:
       LDA    Store8,X            ;Get Object2's Size                            ;4
       ORA    #$10                ;And set to larger size if necessary.          ;2
       STA    NUSIZ1              ;(Used by bridge and invisible surround)       ;3
       RTS                        ;                                              ;6

;Fill cache with two objects in this room.
CacheObjects:
       LDY    LastObj             ;Get Last Object                               ;3
       LDA    #NullNumber         ;Set cache to (Num Is (8 * NumOfObj) - 8)      ;2
       STA    CurrentObject+2     ;      no-ojects.                              ;3
       STA    CurrentObject+3     ;                                              ;3
MoveNextObject:
       TYA                        ;                                              ;2
       CLC                        ;Goto the next object to                       ;2
       ADC    #$08                ;check (add nine).                             ;2
       CMP    #NullNumber         ;Check if over maximum.(Num Is (8*NumOfObj)-8) ;2
       BCC    GetObjectsInfo      ;                                              ;2
       LDA    #SurroundNumber     ;If so, wrap to zero.                          ;2
GetObjectsInfo:
       TAY                        ;                                              ;2
       LDA    Store1,Y            ;Get low byte of object info.                  ;4
       STA    CurrentObject       ;                                              ;3
       LDA    Store2,Y            ;Get high byte of object info.                 ;4
       STA    CurrentObject+1     ;                                              ;3
       LDX    #$00                ;                                              ;2
       LDA    (CurrentObject,X)   ;Get objects current room.                     ;6
       CMP    PlayerRoom          ;Is it in this room?                           ;3
       BNE    CheckForMoreObjects ;If not lets try next object (branch)          ;2
       LDA    CurrentObject+2     ;Check first slot.                             ;3
       CMP    #NullNumber         ;If not default(no-object)(Num Is (8*NumOfObj)-8);2
       BNE    StoreObjectToPrint  ;then branch.                                  ;2
       STY    CurrentObject+2     ;Store this object's number to print           ;3
CheckForMoreObjects:
       CPY    LastObj             ;Have we done all the objets?                  ;3
       BNE    MoveNextObject      ;If not, continue.                             ;2
StoreCount:
       STY    LastObj             ;If so, store current count                    ;3
       RTS                        ;      for next time.                          ;6

StoreObjectToPrint:
       STY    CurrentObject+3     ;Store this object's number to print.          ;3
       JMP    StoreCount          ;      and then give up - no slots free.       ;3

;Convert room number to address...edited to allow up to 128 rooms
RoomNumToAddress:
       STX    Temp             ;save X                                                      ;3
       LDX    #>RoomDataTable  ;initialize the high pointer (this saves one addition)       ;2
       ASL                     ;ROLing carry to $94 not necessary if RoomNumber always <128 ;2
       ASL                     ;ROLing carry to $94 not necessary if RoomNumber always < 64 ;2
       BCC    skipX            ;but you are planning more rooms, so we add the code here    ;2
       INX                     ;                                                            ;2
       INX                     ;                                                            ;2
       CLC                     ;                                                            ;2
skipX:
       ASL                     ;ROLing carry to $94 not necessary if RoomNumber always < 32 ;2
       BCC    skip0            ;but you are planning more rooms, so we add the code here    ;2
       INX                     ;                                                            ;2
       CLC                     ;                                                            ;2
skip0:
       ADC    #<RoomDataTable  ;                                                            ;2
       BCC    skip1            ;                                                            ;2
       INX                     ;                                                            ;2
skip1:
       STA    CurrentObject    ;                                                            ;3
       STX    CurrentObject+1  ;                                                            ;3
       LDX    Temp             ;restore X                                                   ;3
GetObjectState_2:
       RTS                     ;                                                            ;6



;Get pointer to current state.
GetObjectState:
       LDY    #$00                ;                                              ;2
       LDA    State               ;Get the current object state.                 ;3
GetObjectState_1:
       CMP    (CurrentObject),Y   ;Have we found it in the list of states.       ;5
       BCC    GetObjectState_2    ;If nearing it then found it and return        ;2
       BEQ    GetObjectState_2    ;If found it then return.                      ;2
       INY                        ;                                              ;2
       INY                        ;Goto next state in list of states.            ;2
       INY                        ;                                              ;2
       BNE    GetObjectState_1    ;                                              ;2

;Check for input.
CheckInput:
       INC    LoCnt               ;Increment low count.                          ;5
       BNE    GetJoystick         ;                                              ;2
       INC    HiCnt               ;Increment hight count if                      ;5
       BNE    GetJoystick         ;      needed.                                 ;2
       LDA    #$80                ;Wrap the high count (indicating               ;2
       STA    HiCnt               ;      timeout) if needed.                     ;3
GetJoystick:
       LDA    SWCHA               ;Get joystick values.                          ;4
       CMP    #$FF                ;If any movement then branch.                  ;2
       BNE    GetJoystick_2       ;                                              ;2
       LDA    SWCHB               ;Get the console switches                      ;4
       AND    #$03                ;Mask for the reset/select switchs.            ;2
       CMP    #$03                ;Have either of them been used?                ;2
       BEQ    GetJoystick_3       ;If not branch.                                ;2
GetJoystick_2:
       LDA    #$00                ;Zero the high count of the                    ;2
       STA    HiCnt               ;      switches or joystick have been used.    ;3
GetJoystick_3:
       RTS                        ;                                              ;6

;Change color if necessary.
ChangeColor:
       LSR                        ;If bit 0 of the color is set                  ;2
       BCC    ChangeColor_2       ;      then the room is to flash.              ;2
       LDA    LoCnt               ;Use frame counter for color.                  ;3
ChangeColor_2:
       LDY    HiCnt               ;Get the input counter.                        ;3
       BPL    ChangeColor_3       ;If console/stick moved recently then branch   ;2
       EOR    HiCnt               ;Merge the high counter with the color wanted. ;3
       AND    #$FB                ;Keep this color bug merge down the luminance. ;2
ChangeColor_3:
       ASL                        ;And restore original color if necessary.      ;2
       RTS                                                                       ;6

;Get the address of the dynamic information for an object.
GetObjectAddress:
       LDA    Store1,X            ;                                              ;4
       STA    CurrentObject       ;Get and store the low address.                ;3
       LDA    Store2,X            ;                                              ;4
       STA    CurrentObject+1     ;Get and store the high address.               ;3
       RTS                        ;                                              ;6

;Game Start
StartGame:
       SEI                        ;Set Interupts Off                             ;2
       CLD                        ;                                              ;2
       LDX    #$28                ;Clear TIA Registers                           ;2
       LDA    #$00                ;&04-&2C i.e. blank                            ;2
ResetAll:
       STA    NUSIZ0,X            ;Everything And Turn.                          ;4
       DEX                        ;Everything Off.                               ;2
       BPL    ResetAll            ;                                              ;2
       TXS                        ;Reset Stack                                   ;2
SetupVars:
       STA    VSYNC,X             ;Clear &80 to &FF User Vars.                   ;4
       DEX                        ;                                              ;2
       BMI    SetupVars           ;                                              ;2
;added so the number won't flash if an object is in the "zero" room
;NOTE: if room attributes are changed, be sure this points to a darkend room's number
       LDA    #$14                ;load a "dark" room number                     ;2
       STA    SurroundR           ;...and save it to the invisible surround room ;3
       JSR    ThinWalls           ;Position the thin walls (missiles)            ;6
       JSR    SetupRoomObjects    ;Setup objects rooms and positions.            ;6
MainGameLoop:
       JSR    CheckGameStart      ;Check for Game Start                          ;6
       JSR    MakeSound           ;Make noise if necessary                       ;6
       JSR    CheckInput          ;Check for input.                              ;6
       LDA    Control             ;Is The Game Active?                           ;3
       BNE    NonActiveLoop       ;If Not Branch..                               ;2
       LDA    ChaliseR            ;Get the room the Chalise is in.               ;3
       CMP    #WinRoom            ;Is it in the yellow castle?                   ;2
       BNE    MainGameLoop_2      ;If Not Branch..                               ;2
       LDA    #$FF                ;                                              ;2
       STA    NoteCnt             ;Set the note count to maximum.                ;3
       STA    Control             ;Set the game to inactive.                     ;3
       LDA    #$00                ;Set the noise type to end-noise.              ;2
       STA    Sound               ;                                              ;3
MainGameLoop_2:
       LDY    #$00                ;Allow joystick read - all movement.           ;2
       JSR    BallMovement        ;Check ball collisions and move ball.          ;6
       JSR    MoveCarriedObject   ;Move the Carried Object                       ;6
       JSR    DoVSYNC             ;Wait for VSYNC                                ;6
       JSR    SetupRoomPrint      ;Setup the room and objects for display.       ;6
       JSR    PrintDisplay        ;Display the room and objects.                 ;6
       JSR    PickupPutdown       ;Deal with object pickup and putdown.          ;6
       LDY    #$01                ;Disallow joystick read - move vertically only.;2
       JSR    BallMovement        ;Check ball collisions and move ball.          ;6
       JSR    Surround            ;Deal With Invisible Surround Moving.          ;6
       JSR    DoVSYNC             ;Wait for VSYNC                                ;6
       JSR    MoveBat             ;Move and deal with bat.                       ;6
       LDY    #Gates              ;For Each Portcullis.                          ;2
       JSR    Portals_2           ;Move and deal with portcullises.              ;6
       JSR    PrintDisplay        ;Display the room and objects.                 ;6
       JSR    MoveGreenDragon     ;Move and deal with the green dragon.          ;6
       JSR    MoveYellowDragon    ;Move and deal with the yellow dragon.         ;6
       JSR    DoVSYNC             ;Wait for VSYNC.                               ;6
       LDY    #$02                ;Disallow stick read/bridge check-move hor.only;2
       JSR    BallMovement        ;Check ball collisions and move ball.          ;6
       JSR    MoveRedDragon       ;Move and deal with red dragon.                ;6
       JSR    Mag_1               ;Deal with the magnet.                         ;6
       JSR    PrintDisplay        ;Display the room and objects.                 ;6
       BNE    MainGameLoop        ;always branch                                 ;2

;Non Active Game Loop.
NonActiveLoop:
       JSR    DoVSYNC             ;Wait for VSYNC                                ;6
       JSR    PrintDisplay        ;Display the room and objects.                 ;6
       JSR    SetupRoomPrint      ;Set up room and objects for display.          ;6
       BNE    MainGameLoop        ;always branch                                 ;2

;Position missiles to "thin wall" areas.
ThinWalls:
       LDA    #$0D                ;Position missile 00 to                        ;2
       LDX    #$02                ;(0D,00) - left thin wall.                     ;2
       JSR    PoXsSprite          ;                                              ;6
       LDA    #$96                ;Position missile 01 to                        ;2
       INX                        ;                                              ;2
;PoXsSprite does not alter the X register...so we can just increase it
       JSR    PoXsSprite          ;                                              ;6
       STA    WSYNC               ;Wait for horizonal blank.                     ;3
       STA    HMOVE               ;Apply the horizonal move.                     ;3
       RTS                        ;                                              ;6

CheckGameStart:
       LDA    SWCHB               ;Get the console switches.                     ;4
       EOR    #$FF                ;Flip (as reset active low).                   ;2
       AND    Debounce            ;Compare with what was before                  ;3
; testing bit 0 is smaller with LSR:
       LSR                        ;And check only the reset switch               ;2
       BCC    CheckReset          ;If no reset then branch.                      ;2
       LDA    Control             ;Has the Game Started?                         ;3
       CMP    #$FF                ;If not then branch.                           ;2
       BEQ    SetupRoomObjects    ;                                              ;2
       LDA    #$11                ;Get the yellow castle room.                   ;2
       STA    PlayerRoom          ;Make it the current room.                     ;3
       STA    PrevRoom            ;Make it the previous room.                    ;3
       LDA    #$50                ;Get the X coordinate.                         ;2
       STA    PlayerX             ;Make it the current ball X coordinate.        ;3
       STA    PrevX               ;Make it the previous ball X coordinate.       ;3
       LDA    #$20                ;Get the Y coordinate.                         ;2
       STA    PlayerY             ;Make it the current ball Y coordinate.        ;3
       STA    PrevY               ;Make it the previous ball Y coordinate.       ;3
       LDA    #$00                ;                                              ;2
       STA    RDragonR+4          ;Set the red dragon's state to OK.             ;3
       STA    YDragonR+4          ;Set the yellow dragon's state to OK.          ;3
       STA    GDragonR+4          ;Set the green dragon's state to OK.           ;3
       STA    NoteCnt             ;Set the note count to zero.. (ops!??)         ;3
       LDA    #NullNumber         ;(Num Is (8 * NumOfObj) - 8)                   ;2
       STA    CarriedObj          ;Set no object being carried.                  ;3
       BNE    StoreSwitches       ;Always branch                                 ;2
CheckReset:
; testing bit 1 is smaller with LSR:
       LSR                        ;And check only the select switch              ;2
       BCC    StoreSwitches       ;Branch if select not being used.              ;2
       LDA    PlayerRoom          ;Get the Current Room.                         ;3
       BNE    SetupRoomObjects    ;Branch if not.                                ;2
       LDY    Level               ;Increment the level.                          ;3
       INY                        ;Number (by two).                              ;2
       INY                        ;Number (by two).                              ;2
       CPY    #$06                ;Have we reached the maximum?                  ;2
       BCC    ResetSetup          ;                                              ;2
       LDY    #$00                ;If yep then set back to zero.                 ;2
ResetSetup:
       STY    Level               ;Store the new level number.                   ;3

SetupRoomObjects:
       LDA    #$00                ;Set the current room to the                   ;2
       STA    PlayerRoom          ;"Number" room.                                ;3
       STA    PrevRoom            ;And the previous room.                        ;3
;A is still zero...no need to reload
       STA    PlayerY             ;And the previous Y coordinate.                ;3
       STA    PrevY               ;(So can't be seen.)                           ;3
       LDY    Level               ;Get the level number.                         ;3
       LDA    Loc_4,Y             ;Get the low pointer to object locations.      ;4
       STA    CurrentObject       ;                                              ;3
       LDA    Loc_5,Y             ;Get the high pointer to object locations.     ;4
       STA    CurrentObject+1     ;                                              ;3
       LDY    #ByteNum            ;Copy all the objects dynamic information.     ;2
SetupRoomObjects_2:
       LDA    (CurrentObject),Y   ;(the rooms and positions) into                ;5
       STA.wy DotR,Y              ;the working area.                             ;5
       DEY                        ;                                              ;2
       BPL    SetupRoomObjects_2  ;                                              ;2
       LDA    Level               ;Get the level number.                         ;3
       CMP    #$04                ;Branch if level one.                          ;2
       BCC    SignalGameStart     ;Or two(Where all objects are in defined areas);2
       JSR    RandomizeLevel3     ;Put some objects in random rooms.             ;6
       JSR    DoVSYNC             ;Wait for VSYNC                                ;6
       JSR    PrintDisplay        ;Display rooms and objects.                    ;6
SignalGameStart:
       LDA    #$00                ;Signal that the game has started.             ;2
       STA    Control             ;                                              ;3
       LDA    #NullNumber         ;Set no object carried.(Num Is (8*NumOfObj)-8) ;2
       STA    CarriedObj          ;                                              ;3
StoreSwitches:
       LDA    SWCHB               ;Store the current console switches            ;4
       STA    Debounce            ;                                              ;3
       RTS                        ;                                              ;6

;Put objects in random rooms for level 3.
RandomizeLevel3:
       LDY    #RndNum             ;For each of the eleven objects..              ;2
RandomizeLevel3_2:
       LDA    LoCnt               ;Get the low input counter as seed.            ;3
       LSR                        ;                                              ;2
       LSR                        ;                                              ;2
       LSR                        ;Generate a psudo-random                       ;2
       LSR                        ;room number.                                  ;2
       LSR                        ;                                              ;2
       SEC                        ;                                              ;2
       ADC    LoCnt               ;Store the low input counter.                  ;3
       STA    LoCnt               ;                                              ;3
       AND    #RndMax             ;Trim so represents a room value.              ;2
       CMP    Loc_2,Y             ;If it is less than the                        ;4
       BCC    RandomizeLevel3_2   ;lower bound for object then get another.      ;2
       CMP    Loc_3,Y             ;If it equals or is                            ;4
       BEQ    RandomizeLevel3_3   ;Less than the higher bound for object         ;2
       BCS    RandomizeLevel3_2   ;Then continue (branch if higher)              ;2
RandomizeLevel3_3:
       LDX    Loc_1,Y             ;Get the dynamic data index for this object    ;4
       STA    VSYNC,X             ;Store the new room value.                     ;4
       DEY                        ;                                              ;2
       DEY                        ;Goto the next object.                         ;2
       DEY                        ;                                              ;2
       BPL    RandomizeLevel3_2   ;Untill all done                               ;2
       RTS                        ;                                              ;6

;Check ball collisions and move ball.
BallMovement:
; using BIT to check the two most significant bytes:
       BIT    CXBLPF              ;Get ball-playfield collision                  ;3
       BMI    PlayerCollision     ;Branch if collision (Player-Wall)             ;2
       BIT    CXM0FB              ;Get ball-missile00 collision.                 ;3
       BVS    PlayerCollision     ;Branch if collision. (Player-Left Thin)       ;2
       BIT    CXM1FB              ;Get ball-missile01 collision.                 ;3
       BVC    BallMovement_2      ;Branch if no collision.                       ;2
       LDA    CurrentObject+3     ;If object2 (to print) is                      ;3
       CMP    #DotNumber          ;      not the black dot then collide.         ;2
       BNE    PlayerCollision     ;                                              ;2
BallMovement_2:
;using BIT to check the flags instead of AND...
       BIT    CXP0FB              ;                                              ;3
       BVC    BallMovement_3      ;If no collision then branch.                  ;2
       LDA    CurrentObject+2     ;If object1 (to print) is not surround ($00)   ;3
       BNE    PlayerCollision     ;      branch (collision)                      ;2
BallMovement_3:
       BIT    CXP1FB              ;                                              ;3
       BVC    NoCollision         ;If no collision then branch.                  ;2
       LDA    CurrentObject+3     ;If player01 to print is                       ;3
       BEQ    NoCollision         ;No collision - branch.                        ;2
;Player collided (with something)
PlayerCollision:
       CPY    #$02                ;Are we checking for the bridge?               ;2 <-note
       BNE    ReadStick           ;If not, branch.                               ;2
       LDA    CarriedObj          ;Get the object being carried.                 ;3
       CMP    #BridgeNumber       ;Branch if it is the bridge.                   ;2
       BEQ    ReadStick           ;                                              ;2
       LDA    PlayerRoom          ;Get the current room.                         ;3
       CMP    BridgeR             ;Is the bridge in this room.                   ;3
       BNE    ReadStick           ;If not branch.                                ;2
;Check going through the bridge.
       LDA    PlayerX             ;Get the ball's X coordinate.                  ;3
       SEC                        ;                                              ;2
       SBC    BridgeR+1           ;Subtract the bridge's X coordinate.           ;3
       CMP    #$0A                ;If less than &0A then forget it.              ;2
       BCC    ReadStick           ;                                              ;2
       CMP    #$17                ;If more than &17 then forget it.              ;2
       BCS    ReadStick           ;                                              ;2
       LDA    BridgeR+2           ;Get the bridge's Y coordinate.                ;3
       SEC                        ;                                              ;2
       SBC    PlayerY             ;Subtrac the ball's Y coordinate.              ;3
       CMP    #$FC                ;                                              ;2
       BCS    NoCollision         ;If more than &FC then going through bridge.   ;2
       CMP    #$19                ;If more than &19 then forget it.              ;2
       BCS    ReadStick           ;                                              ;2
;No collision (and going through bridge)
NoCollision:
       LDA    #$FF                ;Reset the joystick input.                     ;2
       STA    CurrentStick        ;                                              ;3
       LDA    PlayerRoom          ;Get the current room.                         ;3
       STA    PrevRoom            ;      and store temporarily.                  ;3
       LDA    PlayerX             ;Get the ball's X coordinate.                  ;3
       STA    PrevX               ;      and store temporarily.                  ;3
       LDA    PlayerY             ;Get the ball's Y coordinate.                  ;3
       STA    PrevY               ;And Store Temporarily.                        ;3
;Read Sticks
ReadStick:
; if A is not needed, this is shorter:
       TYA                        ;Check for zero (all movement)                 ;2
       BNE    ReadStick_2         ;If not, don't bother with joystick read.      ;2
       LDA    SWCHA               ;Read joysticks.                               ;4
       STA    CurrentStick        ;      and store value.                        ;3

ReadStick_2:
       LDA    PrevRoom            ;Get Temporary room.                           ;3
       STA    PlayerRoom          ;      and make it the current room.           ;3
       LDA    PrevX               ;Get temporary X coordinate                    ;3
       STA    PlayerX             ;      and make it the man's X coordinate.     ;3
       LDA    PrevY               ;Get temporary Y coordinate                    ;3
       STA    PlayerY             ;      and make it the man's Y coordinate.     ;3
       LDA    CurrentStick        ;Get the Joystick position.                    ;3
       ORA    ReadStick_3,Y       ;Merge out movement not allowed in this phase. ;4
       STA    ObjDir              ;And store cooked movement.                    ;3
       LDX    #PlayerRoom         ;Point to ball's coordiates.                   ;2
       LDY    #$03                ;Set the delta for the ball.                   ;2
; replacing JSR, RTS with JMP is also a very common trick (you can also try BNE here)
       JMP    MoveGroundObject    ;Move the ball                                 ;3


;Deal with object pickup and putdown.
PickupPutdown:
       ROL    INPT4               ;Get joystick trigger.                         ;5
       ROR    Jstick              ;Merge into joystick record.                   ;5
       LDA    Jstick              ;Get joystick record.                          ;3
       AND    #$C0                ;Merge out previous presses.                   ;2
       CMP    #$40                ;Was it previously pressed?                    ;2
       BNE    PickupPutdown_2     ;If not branch.                                ;2
       LDA    #NullNumber         ;(Num Is (8 * NumOfObj) - 8)                   ;2
       CMP    CarriedObj          ;If nothing is being carried                   ;3
       BEQ    PickupPutdown_2     ;      then branch.                            ;2
       STA    CarriedObj          ;Drop object.                                  ;3
       LDA    #$04                ;Set noise type to four.                       ;2
       STA    Sound               ;                                              ;3
       STA    NoteCnt             ;set noise count to four also                  ;3

PickupPutdown_2:
;Check for collision.
       BIT    CXP0FB              ;Get Ball-Player00 collision.                  ;3
       BVC    PickupPutdown_3     ;If nothing occured then branch.               ;2

;With Player00
       LDA    CurrentObject+2     ;Get type of Player00                          ;3
       STA    CurrentObject+4     ;And Store.                                    ;3
       JMP    CollisionDetected   ;Deal with collision.                          ;3

PickupPutdown_3:
       BIT    CXP1FB              ;Get Ball-Player01 collision.                  ;3
       BVC    PickupPutdown_4     ;If nothing has happened, branch.              ;2
       LDA    CurrentObject+3     ;Get type of Player01                          ;3
       STA    CurrentObject+4     ;      and store.                              ;3
       .byte  $24                 ; opcode for BIT (Skip next byte)              ;3
PickupPutdown_4:
       RTS                        ;Deal with no collision (return).              ;6
;Collision occured.
CollisionDetected:
       LDX    CurrentObject+4     ;Get the object collided with.                 ;3
       JSR    GetObjectAddress    ;Get it's dynamic information.                 ;6
       LDA    CurrentObject+4     ;Get the object collided with.                 ;3
       CMP    #SwordNumber        ;Is it carriable?  'SWORD?? 51 SET TO 48       ;2
       BCC    NoObject            ;If not, branch.                               ;2
       LDA    CurrentObject+4     ;Get the object collided with.                 ;3
       CMP    CarriedObj          ;Is it the object being carried?               ;3
       BEQ    PickupObject        ;If so, branch (and actually pick it up.)      ;2
       LDA    #$05                ;Set noise type to five.                       ;2
       STA    Sound               ;                                              ;3
       LDA    #$04                ;Set noise type to four.                       ;2
       STA    NoteCnt             ;                                              ;3

PickupObject:
       LDA    CurrentObject+4     ;                                              ;3
       STA    CarriedObj          ;Set the object as being carried.              ;3
       LDX    CurrentObject       ;Get the dynamice address low byte.            ;3
       LDY    #$06                ;                                              ;2
       LDA    CurrentStick        ;????                                          ;3
       JSR    MoveObjectDelta     ;????                                          ;6
       LDY    #$01                ;                                              ;2
       LDA    (CurrentObject),Y   ;Get the object's X coordinate.                ;5
       SEC                        ;                                              ;2
       SBC    PlayerX             ;Subtract the ball's X coordinate.             ;3
       STA    CarriedX            ;      and store the difference.               ;3
;Y hasn't changed...just use INY instead
       INY                        ;                                              ;2
       LDA    (CurrentObject),Y   ;Get the object's Y coordinate.                ;5
       SEC                        ;                                              ;2
       SBC    PlayerY             ;Subtract the Ball's Y coordinate.             ;3
       STA    CarriedY            ;      and store the difference.               ;3
;No collision
NoObject:
       RTS                        ;                                              ;6


;Move the carried object
MoveCarriedObject:
       LDX    CarriedObj          ;Get the object being carried.                 ;3
       CPX    #NullNumber         ;If nothing, return (Num Is (8*NumOfObj)-8)    ;2
       BEQ    MoveCarriedObject_2 ;                                              ;2
       JSR    GetObjectAddress    ;Get it's dynamic information.                 ;6
       LDY    #$00                ;                                              ;2
       LDA    PlayerRoom          ;Get the current room.                         ;3
       STA    (CurrentObject),Y   ;      and stroe the object's current room.    ;6
;Y hasn't changed...just use INY instead
       INY                                                                       ;2
       LDA    PlayerX             ;Get the ball's X coordinate.                  ;3
       CLC                        ;                                              ;2
       ADC    CarriedX            ;Add the X difference.                         ;3
       STA    (CurrentObject),Y   ;      and store as the object's X coordinate. ;6
;Y hasn't changed...just use INY instead
       INY                        ;                                              ;2
       LDA    PlayerY             ;Get the ball's Y coordinate.                  ;3
       CLC                        ;                                              ;2
       ADC    CarriedY            ;Add the Y difference.                         ;3
       STA    (CurrentObject),Y   ;      and store as the object's Y coordinate. ;6
       LDY    #$00                ;Set no delta.                                 ;2
       LDA    #$FF                ;Set no movement.                              ;2
       LDX    CurrentObject       ;Get the object's dynamic address.             ;3
;Move the object.
MoveGroundObject:
       JSR    MoveObjectDelta     ;Move the object by delta.                     ;6
       LDY    #Gates              ;Set to do the three                           ;2
MoveGroundObject_2:
       STY    ObjAddress          ;      portcullises.                           ;3
       LDA.wy YGateR,Y            ;Get the portal state.                         ;4
       CMP    #$1C                ;Is it in a closed state?                      ;2
       BEQ    GetPortal           ;If not, next portal.                          ;2

;Deal with object moving out of a castle.
       LDY    ObjAddress          ;Get port number.                              ;3
       LDA    VSYNC,X             ;Get object's room number.                     ;4
       CMP    EntryRoomOffsets,Y  ;Is it in a castle entry room.                 ;4
       BNE    GetPortal           ;If not, next portal.                          ;2
       LDA    WSYNC,X             ;Get the object's Y coordinate.                ;4
       CMP    #$0D                ;Is it above &OD i.e at the bottom.            ;2
       BPL    GetPortal           ;If so then branch.                            ;2
       LDA    CastleRoomOffsets,Y ;Get the castle room.                          ;4
       STA    VSYNC,X             ;And put the object in the castle room.        ;4
       LDA    #$50                ;                                              ;2
       STA    VBLANK,X            ;Set the object's new X coordinate.            ;4
       LDA    #$2C                ;                                              ;2
       STA    WSYNC,X             ;Set the new object's Y coordinate.            ;4
       LDA    #$01                ;                                              ;2
       STA.wy YGateR,Y            ;Set the portcullis state to 01.               ;5
MoveCarriedObject_2:
       RTS                        ;                                              ;6

GetPortal:
       LDY    ObjAddress          ;Get the portcullis number.                    ;3
       DEY                        ;      goto next,                              ;2
       BPL    MoveGroundObject_2  ;      and continue.                           ;2

;Check and Deal with Up.
       LDA    WSYNC,X             ;Get the object's Y coordinate.                ;4
       CMP    #$6A                ;Has it reached above the top.                 ;2
       BMI    DealWithLeft        ;If not, branch.                               ;2
       LDA    #$0D                ;Set new Y coordinate to bottom.               ;2
       STA    WSYNC,X             ;                                              ;4
       LDY    #$04                ;Get the direction wanted.                     ;2
       BNE    GetNewRoom          ;Go and get new room.                          ;2
;Check and Deal with Left.
DealWithLeft:
       LDA    VBLANK,X            ;Get the object's X coordinate.                ;4
       CMP    #$03                ;Is it Three or less?                          ;2
       BCC    DealWithLeft_2      ;If so, branch.  (off to left)                 ;2
       CMP    #$F0                ;Is it's &F0 or more.                          ;2
       BCC    DealWithDown        ;If not, branch. (off to left)                 ;2
DealWithLeft_2:
       CPX    #PlayerRoom         ;Are we dealling with the ball?                ;2
       BEQ    DealWithLeft_3      ;If so Branch.                                 ;2
       LDA    #$9A                ;Set new X coordinate for the others.          ;2
       .byte  $2C                 ; opcode for BIT.w (Skip next 2 bytes)         ;4
DealWithLeft_3:
       LDA    #$9E                ;Set new X coordinate for the ball.            ;2
DealWithLeft_4:
       STA    VBLANK,X            ;Store the next X coordinate.                  ;4
       LDY    #$07                ;And get the direction wanted.                 ;2
       BNE    GetNewRoom          ;Go and get new room.                          ;2

;Check and Deal with Down.
DealWithDown:
       LDA    WSYNC,X             ;Get object's Y coordinate.                    ;4
       CMP    #$0D                ;If it's greater than &0D then                 ;2
       BCS    DealWithRight       ;Branch.                                       ;2
       LDA    #$69                ;Set new Y coordinate.                         ;2
       STA    WSYNC,X             ;                                              ;4
       LDY    #$06                ;Get the direction wanted.                     ;2
       BNE    GetNewRoom          ;Go and get new room.                          ;2

;Check and Deal with Right.
DealWithRight:
       LDA    VBLANK,X            ;Get the object's X coordinate.                ;4
       CPX    #PlayerRoom         ;Are we dealing with the ball.                 ;2
       BNE    DealWithRight_2     ;Branch if not.                                ;2
       CMP    #$9F                ;Has the object reached the right?             ;2
       BCC    MovementReturn      ;Branch if not.                                ;2
       LDA    VSYNC,X             ;Get the Ball's Room.                          ;4
       CMP    #$03                ;Is it room #3 (Right to secret room)          ;2
       BNE    DealWithRight_3     ;Branch if not.                                ;2
       LDA    DotR                ;Check the room of the black dot.              ;3
       CMP    #$15                ;Is it in the hidden room area?                ;2
       BEQ    DealWithRight_3     ;If so, Branch.                                ;2

;Manually change to secret room.
       LDA    #$1E                ;Set room to secret room.                      ;2
       STA    VSYNC,X             ;And make it current.                          ;4
       LDA    #$03                ;Set the X coordinate.                         ;2
       STA    VBLANK,X            ;                                              ;4
       RTS                        ;                                              ;6
DealWithRight_2:
       CMP    #$9B                ;Has the object reached the right of screen?   ;2
       BCC    MovementReturn      ;Branch if not (no room change)                ;2

DealWithRight_3:
       LDA    #$03                ;Set the next X coordinate.                    ;2
       STA    VBLANK,X            ;                                              ;4
       LDY    #$05                ;And get the direction wanted.                 ;2
;Get new room
GetNewRoom:
       LDA    VSYNC,X             ;Get the object's room.                        ;4
       JSR    RoomNumToAddress    ;Convert it to an address.                     ;6
       LDA    (CurrentObject),Y   ;Get the adjacent room.                        ;5
       JSR    AdjustRoomLevel     ;Deal with the level differences.              ;6
       STA    VSYNC,X             ;      and store as new object's room.         ;4
MovementReturn:
       RTS                        ;                                              ;6

;Move the object in direction by delta.
MoveObjectDelta:
       STA    ObjDir              ;Stored direction wanted.                      ;3
MoveObjectDelta_2:
       DEY                        ;Count down the delta.                         ;2
       BMI    MovementReturn      ;                                              ;2

;more use of the BIT instruction...
       BIT    ObjDir              ;Get direction wanted.                         ;3
       BMI    MoveObjectDelta_3   ;If no move right then branch.                 ;2
       INC    VBLANK,X            ;Increment the X coordinate.                   ;6

MoveObjectDelta_3:
       BIT    ObjDir              ;Get the direction wanted.                     ;3
       BVS    MoveObjectDelta_4   ;If no move left then branch.                  ;2
       DEC    VBLANK,X            ;Decrement the X coordinate.                   ;6

MoveObjectDelta_4:
       LDA    ObjDir              ;Get the direction wanted.                     ;3
       AND    #$10                ;Check for move up.                            ;2
       BNE    MoveObjectDelta_5   ;If no move up then branch.                    ;2
       INC    WSYNC,X             ;                                              ;6

MoveObjectDelta_5:
       LDA    ObjDir              ;Get direction wanted.                         ;3
       AND    #$20                ;Check for move down.                          ;2
       BNE    MoveObjectDelta_2   ;If no move down the branch.                   ;2
       DEC    WSYNC,X             ;Decrement the Y coordinate.                   ;6
       JMP    MoveObjectDelta_2   ;Keep going until delta finished.              ;3

;Adjust room for different levels.
AdjustRoomLevel:
       CMP    #$80                ;Is the room number                            ;2
       BCC    AdjustRoomLevel_2   ;      above &80?                              ;2
       SEC                        ;                                              ;2
       SBC    #$80                ;Remove the &80 flag and                       ;2
       STA    Temp                ;      store the room number.                  ;3
       LDA    Level               ;Get the level number.                         ;3
       LSR                        ;Divide it by two.                             ;2
       CLC                        ;                                              ;2
       ADC    Temp                ;Add to the original room.                     ;3
       TAY                        ;                                              ;2
       LDA    RoomDiffs,Y         ;Use as an offset to get the next room.        ;4
AdjustRoomLevel_2:
       RTS                        ;                                              ;6

;Get player-ball collision.
PBCollision:
       CMP    CurrentObject+2     ;Is it the first object?                       ;3
       BEQ    PBCollision_2       ;YES - Then Branch.                            ;2
       CMP    CurrentObject+3     ;Is it the second object?                      ;3
       BEQ    PBCollision_3       ;YES - Then Branch.                            ;2
       LDA    #$00                ;Otherwise, nothing.                           ;2
       RTS                        ;                                              ;6

PBCollision_2:
       LDA    CXP0FB              ;Get player00-ball collision.                  ;3
       .byte  $2C                 ; opcode for BIT.w (Skip next 2 bytes)         ;4
PBCollision_3:
       LDA    CXP1FB              ;Get player01-ball collision.                  ;3
       AND    #$40                ;                                              ;2
       RTS                        ;                                              ;6


;Find which object has hit object wanted.
FindObjHit:
       BIT    CXPPMM              ;Get Player00-Player01                         ;3
       BPL    FindObjHit_2        ;If nothing, Branch.                           ;2
       CPX    CurrentObject+2     ;Is object 1 the one being hit?                ;3
       BEQ    FindObjHit_3        ;If so, Branch.                                ;2
       CPX    CurrentObject+3     ;Is object 2 the one being hit?                ;3
       BEQ    FindObjHit_4        ;If so, Branch.                                ;2

FindObjHit_2:
       LDA    #NullNumber         ;Yes, select the other.(Num Is (8*NumOfObj)-8) ;2
       RTS                        ;                                              ;6

FindObjHit_3:
       LDA    CurrentObject+3     ;Yes, select the other.(Num Is (8*NumOfObj)-8) ;3
       RTS                        ;                                              ;6

FindObjHit_4:
       LDA    CurrentObject+2     ;Yes, select the other.(Num Is (8*NumOfObj)-8) ;3
       RTS                        ;                                              ;6


;Move object.
MoveGameObject:
       JSR    GetLinkedObject     ;Get liked object and movement.                ;6
       LDX    Delta1              ;Get dynamic data address.                     ;3
       LDA    ObjDir              ;Get Movement.                                 ;3
       BNE    MoveGameObject_2    ;If movement then branch.                      ;2
       LDA    RSYNC,X             ;Use old movement.                             ;4

MoveGameObject_2:
       STA    RSYNC,X             ;Store the new movement.                       ;4
       LDY    Delta2              ;Get the object's Delta.                       ;3
       JMP    MoveGroundObject    ;Move the object.                              ;6

;Find liked object and get movement.
GetLinkedObject:
       LDA    #$00                ;Set index to zero.                            ;2
       STA    Index               ;                                              ;3

GetLinkedObject_2:
       LDY    Index               ;Get index.                                    ;3
       LDA    (ObjLst),Y          ;Get first object.                             ;5
       TAX                        ;                                              ;2
       INY                        ;                                              ;2
       LDA    (ObjLst),Y          ;Get second object.                            ;5
       TAY                        ;                                              ;2
       LDA    VSYNC,X             ;Get object1's room.                           ;4
       CMP.wy VSYNC,Y             ;Compare with object2's room.                  ;4
       BNE    GetLinkedObject_3   ;If not the same room then branch.             ;2
       CPY    ObjCr               ;Have we matched the second object             ;3
       BEQ    GetLinkedObject_3   ;      for difficulty (if so, carry on).       ;2
       CPX    ObjCr               ;Have we matched the first object              ;3
; here we can combine two tricks:
       BNE    GetLinkedObject_4   ;Get object's movement.                        ;6

GetLinkedObject_3:
       INC    Index               ;Increment the index.                          ;5
       INC    Index               ;                                              ;5
       LDY    Index               ;Get the index number.                         ;3
       LDA    (ObjLst),Y          ;Check for end of sequence.                    ;5
       BNE    GetLinkedObject_2   ;If not branch.                                ;2
       STA    ObjDir              ;      liked object is found.                  ;3
       RTS                        ;                                              ;6

;Work out object's movement.
GetLinkedObject_4:
       LDA    #$FF                ;Set object movement to none.                  ;2
       STA    ObjDir              ;                                              ;3
       LDA.wy VSYNC,Y             ;Get oject2's room.                            ;4
       CMP    VSYNC,X             ;Compare it with object's room.                ;4
       BNE    GetLinkedObject_8   ;If not the same, forget it.                   ;2
       LDA.wy VBLANK,Y            ;Get Object2's X coordinate.                   ;4
       CMP    VBLANK,X            ;Get Object1's X coordinate.                   ;4
       BCC    GetLinkedObject_5   ;If Object2 to left of Object1 then Branch.    ;2
       BEQ    GetLinkedObject_6   ;If Object2 on Object1 then Branch.            ;2
; this one is a bit tricky:
; 1. v1 AND v2 == v2 AND v1, so we can swap this
; 2. now we can resuse the AND and STA code
; 3. we use bit to "hide" the next instruction and save a jump
       LDA    #$7F                ;Signal a move right.                          ;2
       .byte  $2C                 ; opcode for BIT.w (Skip next 2 bytes)         ;4
GetLinkedObject_5:
       LDA    #$BF                ;Signal a move left.                           ;2
GetLinkedObject_5b
       AND    ObjDir              ;Get object movement.                          ;3
       STA    ObjDir              ;                                              ;3
GetLinkedObject_6:
       LDA.wy WSYNC,Y             ;Get Object2's Y Coordinate.                   ;4
       CMP    WSYNC,X             ;Get Object1's X Coordinate.                   ;4
       BCC    GetLinkedObject_7   ;If Object2 Below Object1 Then Branch.         ;2
       BEQ    GetLinkedObject_8   ;If Object2 on Object1 Then Branch.            ;2
       LDA    #$EF                ;Signal a move up.                             ;2
       BNE    GetLinkedObject_9   ;Always branch                                 ;2
GetLinkedObject_8:
       LDA    ObjDir              ;Get the Move.                                 ;3
       RTS                        ;                                              ;6
GetLinkedObject_7:
       LDA    #$DF                ;Signal a move down.                           ;2
GetLinkedObject_9:
       AND    ObjDir              ;Get object movement.                          ;3
       STA    ObjDir              ;                                              ;3
       RTS                        ;                                              ;6



; WARNING! This optimization is rather complicated:
; a. we move all tables before the code for two reasons:
;    1. to have them close together (they *must* be on the same page!)
;    2. to avoid to jump over them
; b. we try to reuse as much code as possible
; c. we replace JSR, RTS with BNE

;Move the Red Dragon
MoveRedDragon:
       LDA    #<RedDragMatrix     ;                                              ;2
       LDY    #$03                ;                                              ;2
       LDX    #RDragonNumber      ;Select Dragon #1 : Red                        ;2
       BNE    MoveDragon          ;                                              ;2

;Move the Yellow Dragon.
MoveYellowDragon:
       LDA    #<YelDragMatrix     ;                                              ;2
       LDY    #$02                ;                                              ;2
       LDX    #YDragonNumber      ;                                              ;2
       BNE    MoveDragon          ;Select Dragon #2 : Yellow.                    ;3

;Move the Green Dragon
MoveGreenDragon:
       LDA    #<GreenDragonMatrix ;                                              ;2
       LDY    #$02                ;                                              ;2
       LDX    #GDragonNumber      ;Select Dragon #3 : Green                      ;2

;Move A Dragon
MoveDragon:
       STA    ObjLst              ;Set Low Address of Object Store.              ;3
       STY    Delta2              ;Set the Green Dragon's Delta.                 ;3

    IF (>RedDragMatrix != >YelDragMatrix) || (>RedDragMatrix != >GreenDragonMatrix)
; If this error occurs, the optimization doesn't work because the three tables are not on the same page.
; You can try to move them somewhere else, the best way is to move all data at the end of the code. There
; you can rearrange them much easier.1
       ECHO "Error: High DragonMatrix pointer not equal!"
       ERR
    ENDIF

       LDA    #>RedDragMatrix     ;                                              ;2
       STA    ObjLst+1            ;Set High Address of Object Store.             ;3
       STX    ObjectNumber        ;Save Object were dealing with.                ;3
       LDA    Store1,X            ;Get the Object's Dynamic Data.                ;4
       TAX                        ;                                              ;2
       LDA    NUSIZ0,X            ;Get the Object's State.                       ;4
       BNE    MoveDragon_6        ;Branch if not.                                ;2
;Dragon Normal (State 1)
       BIT    SWCHB               ;Read console switches.                        ;4
       BPL    MoveDragon_2        ;If Amateur Branch.                            ;2
;NOTE:A is already zero from the NUSIZ0 comparison done above that fell through to here :)
       .byte  $2C                 ; opcode for BIT.w (Skip next 2 bytes)         ;4
MoveDragon_2:
       LDA    #SwordR             ;Set Easy - Ignore Sword.                      ;2
MoveDragon_3:
       STA    ObjCr               ;Store Difficulty                              ;3
       STX    Delta1              ;Store Dynamic Data Address.                   ;3
       JSR    MoveGameObject      ;                                              ;6
       LDA    ObjectNumber        ;Get Object                                    ;3
       JSR    PBCollision         ;      And get the Player-Ball collision.      ;6
       BEQ    MoveDragon_4        ;If None Then Branch.                          ;2
       LDA    SWCHB               ;Get Console Switched.                         ;4
       ROL                        ;Move P0 difficulty to                         ;2
       ROL                        ;      bit 01 position.                        ;2
       ROL                        ;                                              ;2
       AND    #$01                ;Mask it out.                                  ;2
       ORA    Level               ;Merge in the Level Number.                    ;3
       TAY                        ;Create Lookup.                                ;2
       LDA    DragonDiff,Y        ;Get New State.                                ;4
       STA    NUSIZ0,X            ;Store as Dragon's State (Open Mouthed).       ;4
       LDA    PrevX               ;                                              ;3
       STA    VBLANK,X            ;Get Temp Ball X Coord and Store as Dragon's.  ;4
       LDA    PrevY               ;                                              ;3
       STA    WSYNC,X             ;Get Temp Ball Y Coord and Store as Dragon's   ;4
       LDA    #$01                ;                                              ;2
       STA    Sound               ;Set Noise Type to 01                          ;3
       LDA    #$10                ;                                              ;2
       STA    NoteCnt             ;Set Noise Count to 10 i.e. make roar noise.   ;3
MoveDragon_4:
       STX    ObjAddress          ;Store Object's Dynamic Data Address.          ;3
       LDX    ObjectNumber        ;Get the Object Number.                        ;3
       JSR    FindObjHit          ;See if anoher object has hit the dragon.      ;6
       LDX    ObjAddress          ;Get the Object Address.                       ;3
       CMP    #SwordNumber        ;Has the Sword hit the Dragon?                 ;2
       BNE    MoveDragon_5        ;If Not, Branch.                               ;2
       LDA    #$01                ;Set the State to 01 (Dead)                    ;2
       STA    NUSIZ0,X            ;                                              ;4
       LDA    #$03                ;Set Sound Three.                              ;2
       STA    Sound               ;                                              ;3
       LDA    #$10                ;Set a Noise count of &10.                     ;2
       STA    NoteCnt             ;                                              ;3
MoveDragon_5:
       RTS                        ;                                              ;6

MoveDragon_6:
       CMP    #$01                ;Is it in State 01 (Dead)                      ;2
       BEQ    MoveDragon_9        ;Branch if So (Return)                         ;2
       CMP    #$02                ;Is it int State 02 (Normal #2)                ;2
       BNE    MoveDragon_7        ;Branch if Not.                                ;2
;Normal Dragon State 2 (Eaten Ball)
       LDA    VSYNC,X             ;Get the Dragon's Current Room.                ;4
       STA    PlayerRoom          ;Store as the Ball's Current Room              ;3
       STA    PrevRoom            ;      and Previous Room.                      ;3
       LDA    VBLANK,X            ;Get the Dragon's X Coordinate.                ;4
       CLC                        ;                                              ;2
       ADC    #$03                ;Adjust                                        ;2
       STA    PlayerX             ;      and store as the ball's X coordinate.   ;3
       STA    PrevX               ;      and previous X coordinate.              ;3
       LDA    WSYNC,X             ;Get the Dragon's Y coordinate.                ;4
       SEC                        ;                                              ;2
       SBC    #$0A                ;Adjust                                        ;2
       STA    PlayerY             ;      and store as the ball's Y coordinate.   ;3
       STA    PrevY               ;      and the previous Y coordinate.          ;3
       RTS                        ;                                              ;6

;Dragon Roaring.
MoveDragon_7:
       INC    NUSIZ0,X            ;Increment the Dragon's State.                 ;6
       LDA    NUSIZ0,X            ;Get it's State.                               ;4
       CMP    #$FC                ;Is it near the end?                           ;2
       BCC    MoveDragon_9        ;If Not, Branch.                               ;2
       LDA    ObjectNumber        ;Get the Dragon's Number.                      ;3
       JSR    PBCollision         ;Check if the Ball is colliding.               ;6
       BEQ    MoveDragon_9        ;If not, Branch.                               ;2
       LDA    #$02                ;Set the State to State 02 : Eaten             ;2
       STA    NUSIZ0,X            ;                                              ;4
       LDA    #$02                ;Set noise two.                                ;2
       STA    Sound               ;                                              ;3
       LDA    #$10                ;Set the Count of Noise to &10.                ;2
       STA    NoteCnt             ;                                              ;3
       LDA    #$9B                ;Get the Maximum X Coordinate.                 ;2
       CMP    VBLANK,X            ;Compare with the Dragon's X Coordinate.       ;4
       BEQ    MoveDragon_8        ;                                              ;2
       BCS    MoveDragon_8        ;                                              ;2
       STA    VBLANK,X            ;If too large then Use It.                     ;4
MoveDragon_8:
       LDA    #$17                ;Set Minimum Y Coordinate.                     ;2
       CMP    WSYNC,X             ;Compare with the Dragon's Y Coordinate.       ;4
       BCC    MoveDragon_9        ;                                              ;2
       STA    WSYNC,X             ;If Too Small, set as Dragon's Y coordinate.   ;4
MoveDragon_9:
       RTS                        ;                                              ;6

;Move Bat
MoveBat:
       INC    BatR+4              ;Put Bat in the Next State.                    ;5
       LDA    BatR+4              ;Get the Bat State.                            ;3
       AND    #$07                ;Has it Reached the Maximum?                   ;2
       STA    BatR+4              ;(reset to zero when bit 3 is reached)         ;3
       LDA    BatR+6              ;Get the Bat Fed-Up Value.                     ;3
       BEQ    MoveBat_3           ;If Bat Fed-Up then Branch.                    ;2
       INC    BatR+6              ;Increment its value for next time.            ;5
       LDA    BatR+3              ;Get the Bat's Movement.                       ;3
       LDX    #BatR               ;Position to Bat.                              ;2
       LDY    #$03                ;Get the Bat's Deltas.                         ;2
       JSR    MoveGroundObject    ;Move the Bat.                                 ;6
       JMP    MoveBat_4           ;Update the Bat's Object.                      ;3

;Bat Fed-Up
MoveBat_3:
       LDA    #BatR               ;Store the Bat's Dynamic Data Address          ;2
       STA    Delta1              ;                                              ;3
       LDA    #$03                ;Set the Bat's Delta.                          ;2
       STA    Delta2              ;                                              ;3
       LDA    #<BatMatrix         ;Set the Low Address of Object Store.          ;2
       STA    ObjLst              ;                                              ;3
       LDA    #>BatMatrix         ;Set the High Address of Object Store.         ;2
       STA    ObjLst+1            ;                                              ;3
       LDA    BatR+5              ;Get Object being Carried by Bat,              ;3
       STA    ObjCr               ;      And Copy.                               ;3
       JSR    MoveGameObject      ;Move the Bat.                                 ;6
       LDY    Index               ;Get Object Liked Index.                       ;3
       LDA    (ObjLst),Y          ;Look up the Object Found in the Table.        ;5
       BEQ    MoveBat_4           ;If nothing found then Forget it.              ;2
       INY                        ;                                              ;2
       LDA    (ObjLst),Y          ;Get the Object Wanted.                        ;5
       TAX                        ;                                              ;2
       LDA    VSYNC,X             ;Get the Object's Room.                        ;4
       CMP    BatR                ;Is it the Same as the Bats?                   ;3
       BNE    MoveBat_4           ;If not Forget it.                             ;2

;See if Bat Can pick up Object.
       LDA    VBLANK,X            ;Get the Object's X Coordinate.                ;4
       SEC                        ;                                              ;2
       SBC    BatR+1              ;Find the differenct with the Bat's            ;3
       CLC                        ;X coordinate.                                 ;2
       ADC    #$04                ;Adjust so Bat in middle of object.            ;2
       AND    #$F8                ;Is Bat within Seven Pixels?                   ;2
       BNE    MoveBat_4           ;If not, no pickup possible.                   ;2
       LDA    WSYNC,X             ;Get the Object's Y Coordinate.                ;4
       SEC                        ;                                              ;2
       SBC    BatR+2              ;Find the Difference with the Bat's            ;3
       CLC                        ;      Y Coordinate.                           ;2
       ADC    #$04                ;Adjust.                                       ;2
       AND    #$F8                ;Is the Bat within Seven Pixels?               ;2
       BNE    MoveBat_4           ;If not, No Pickup Possible.                   ;2

;Get Object
       STX    BatR+5              ;Store Object as Being Carried.                ;3
       LDA    #$10                ;Reset the Bat Fed Up Time.                    ;2
       STA    BatR+6              ;                                              ;3

;Move Object Being Carried by Bat.
MoveBat_4:
       LDX    BatR+5              ;Get Object Being Carried by Bat.              ;3
       LDA    BatR                ;Get the Bat's Room.                           ;3
       STA    VSYNC,X             ;Store this as the Object's Room.              ;4
       LDA    BatR+1              ;Get the Bat's X coordinate.                   ;3
       CLC                        ;                                              ;2
       ADC    #$08                ;Adjust to the Right.                          ;2
       STA    VBLANK,X            ;Make it the Object's X coordinate.            ;4
       LDA    BatR+2              ;Get the Bat's Y Coordinate.                   ;3
       STA    WSYNC,X             ;Store it as the Object's Y Coordinate.        ;4
       LDA    BatR+5              ;Get the Object Being Carried by the Bat.      ;3
       LDY    CarriedObj          ;Get the Object Being Carried by the Ball.     ;3
       CMP    Store1,Y            ;Are the the Same?                             ;4
       BNE    MoveBat_5           ;If not Branch.                                ;2
       LDA    #NullNumber         ;Set Nothing Carried. (Num Is (8*NumOfObj)-8)  ;2
       STA    CarriedObj          ;                                              ;3
MoveBat_5:
       RTS                        ;                                              ;6




;Deal with Portcullis and Collisions.
Portals_2:
       LDX    PortOffsets,Y       ;Get the Portcullises offset number.           ;4
       JSR    FindObjHit          ;See if an Object Collided with it.            ;6
       STA    CurrentObject+4     ;      Store that Object.                      ;3
       LDX    YGateR,Y            ;                                              ;4
       CMP    KeyOffsets,Y        ;Is it the Associated Key?                     ;4
       BNE    Portals_3           ;If not then Branch.                           ;2
       INX                        ;Change it's state to open it.                 ;2
Portals_3:
       STX    YGateR,Y            ;Save its State.                               ;4
       CPX    #$1C                ;Is it Closed?                                 ;2
       BEQ    Portals_9           ;Yes - then Branch.                            ;2
       LDA    PortOffsets,Y       ;Get Portcullis number.                        ;4
       JSR    PBCollision         ;Get the Player-Ball Collision.                ;6
       BEQ    Portals_4           ;If Not Then Branch.                           ;2
       LDX    #$01                ;Set the Portcullis to Closed.                 ;2
       STX    YGateR,Y            ;                                              ;4
       LDX    #PlayerRoom         ;Set to the Castle.                            ;2
       BNE    Portals_6           ;Put the Ball in the Castle.                   ;2
Portals_4:
       LDA    CurrentObject+4     ;Get the Object that hit the Portcullis.       ;3
       CMP    #NullNumber         ;Is it nothing?  (Num Is (8 * NumOfObj) - 8)   ;2
       BEQ    Portals_7           ;If so, Branch.                                ;2
       LDX    CurrentObject+4     ;Get Object.                                   ;3
       STY    ObjAddress          ;Save Y                                        ;3
       JSR    GetObjectAddress    ;And find it's Dynamic Address.                ;6
       LDY    ObjAddress          ;Retrieve Y                                    ;3
       LDX    CurrentObject       ;Get Object's Address.                         ;3
Portals_6:
       LDA    EntryRoomOffsets,Y ;Look up Castle endry room for this port.       ;4
       STA    VSYNC,X             ;Make it the object's Room.                    ;4
       LDA    #$10                ;Give the Object a new Y coordinate.           ;2
       STA    WSYNC,X             ;                                              ;4
Portals_7:
       LDX    YGateR,Y            ;Get its State.                                ;4
       CPX    #$01                ;Is it Open?                                   ;2
       BEQ    Portals_9           ;Yes - Then Branch.                            ;2
       INX                        ;                                              ;2
       CPX    #$38                ;Has it reached the maximum state.             ;2
       BNE    Portals_8           ;If not, Branch.                               ;2
       LDX    #$01                ;Set to Closed State.                          ;2
Portals_8:
       STX    YGateR,Y            ;                                              ;4
Portals_9:
       DEY                        ;Goto the next portcullis.                     ;2
       BPL    Portals_2           ;Do next portcullis.                           ;2
       RTS                        ;                                              ;6



;Deal With Magnet.
Mag_1:
       LDA    MagnetR+2           ;Get Magnet's Y Coordinate.                    ;3
       SEC                        ;                                              ;2
       SBC    #$08                ;Adjust to it's "Poles".                       ;2
       STA    MagnetR+2           ;                                              ;3
       LDA    #$00                ;Con Difficulty!                               ;2
       STA    ObjCr               ;                                              ;3
       LDA    #<MagnetMatrix      ;Set Low Address of Object Store.              ;2
       STA    ObjLst              ;                                              ;3
       LDA    #>MagnetMatrix      ;Set High Address of Object Store.             ;2
       STA    ObjLst+1            ;                                              ;3
       JSR    GetLinkedObject     ;Get Liked Object and Set Movement.            ;6
       LDA    ObjDir              ;Get Movement.                                 ;3
       BEQ    Mag_2               ;If None, then Forget It.                      ;2
       LDY    #$01                ;Set Delta to One.                             ;2
       JSR    MoveGroundObject    ;Move Object.                                  ;6

Mag_2:
       LDA    MagnetR+2           ;Reset the Magnet's                            ;3
       CLC                        ;      Y Coordinate.                           ;2
       ADC    #$08                ;                                              ;2
       STA    MagnetR+2           ;                                              ;3
       RTS                        ;                                              ;6

;Deal with Invisible Surround Moving.
Surround:
       LDA    PlayerRoom          ;Get the Current Room.                         ;3
       JSR    RoomNumToAddress    ;Convert it to an Address.                     ;6
       LDY    #$02                ;                                              ;2
       LDA    (CurrentObject),Y   ;Get the Room's Color.                         ;5
       CMP    #$08                ;Is it Invisible?                              ;2
       BEQ    Surround_2          ;If So Branch.                                 ;2
       LDA    #$00                ;If not, signal the                            ;2
       STA    SurroundR+2         ;      Invisible surround not                  ;3
       RTS                        ;                                              ;6

Surround_2:
       LDA    PlayerRoom          ;Get the Current Room.                         ;3
       STA    SurroundR           ;And store as the Invisible Surrounds.         ;3
       LDA    PlayerY             ;Get the Ball's Y Coordinate.                  ;3
       CLC                        ;                                              ;2
       ADC    #$0E                ;Adjust for Surround.                          ;2
       STA    SurroundR+2         ;      and store as surround's Y coordinate.   ;3
       LDA    PlayerX             ;Get the Ball's X Coordinate.                  ;3
       SEC                        ;                                              ;2
       SBC    #$0E                ;Adjust for Surround,                          ;2
       BPL    Surround_4          ;00 to 7F OK                                   ;2
       CMP    #$F0                ;Is it close to the right edge?                ;2
       BCC    Surround_3          ;Branch if not.                                ;2
       LDA    #$01                ;Flick surround to the                         ;2
       .byte  $2C                 ; opcode for BIT.w (Skip next 2 bytes)         ;4
Surround_3:
       LDA    #$7F                ;If higher than $7F, keep boundry on the right ;2
Surround_4:
       STA    SurroundR+1         ;      and store as surround's X coordinate.   ;3
       RTS                        ;                                              ;6



;Make A Noise.
MakeSound:
       LDY    #$00                ;                                              ;2
       LDA    NoteCnt             ;Check Not Count.                              ;3


;NOTE: remove this next line and uncomment the following section to add noise for the bat
       BEQ    NoiseSaveVolume     ;Branch if no noise to be made                 ;2

;       BNE    MakeSound_2         ;Branch if Noise to be made.                   ;2
;       LDX    PlayerRoom          ;Get the Current Room.                         ;3
;       CPX    BatR                ;Is it the bat's room?                         ;3
;       BNE    NoiseSaveVolume     ;Always branch                                 ;2
;MakeSound_1:
;       LDA    BatR+4              ;Use bat's state for flutter sound             ;3
;       EOR    #$07                ;                                              ;2
;       INY                        ;                                              ;2
;       LDX    #$08                ;                                              ;2
;       BPL    NoiseSave           ;Always branch                                 ;2
MakeSound_2:
       DEC    NoteCnt             ;Goto the Next Note.                           ;5
       LDX    Sound               ;Get the Noise Type.                           ;3
       BEQ    NoiseGameOver       ;Game Over                                     ;2
       DEX                        ;Roar                                          ;2
       BEQ    NoiseRoar           ;                                              ;2
       DEX                        ;Man Eaten.                                    ;2
       BEQ    EatenNoise          ;                                              ;2
       DEX                        ;Dying Dragon.                                 ;2
       BEQ    DragDieNoise        ;                                              ;2
       DEX                        ;Dropping Object.                              ;2
       BEQ    NoiseDropObject     ;                                              ;2
       DEX                        ;Picking up Object.                            ;2
       BEQ    NoiseGetObject      ;                                              ;2
       RTS                        ;                                              ;6

;Sounds...Set A (Frequency), Y (Volume), and X (distortion)...& branch to NoiseSave
;Noise 0 : Game Over
NoiseGameOver:
       LDA    NoteCnt             ;                                              ;3
       STA    COLUPF              ;Color-Luminance Playfield.                    ;3
       TAX                        ;Audio-Control 00                              ;2
       LSR                        ;                                              ;2
       TAY                        ;Audio-Volume 00                               ;2
       LSR                        ;                                              ;2
       LSR                        ;                                              ;2
       BPL    NoiseSave           ;Always branch                                 ;2
;Noise 1 : Roar
NoiseRoar:
       LDA    NoteCnt             ;Get noise count.                              ;3
       TAY                        ;      the Volume.                             ;2
       LSR                        ;                                              ;2
       LDX    #$03                ;If it was even then                           ;2
       BCS    SetVolume           ;Branch.                                       ;2
       LDX    #$08                ;Get a different audio control value.          ;2
SetVolume:
       TYA                        ;      the Volume.                             ;2
       CLC                        ;                                              ;2
       ADC    #$70                ;Set the Frequency.                            ;2
NoiseFrequency:
       LSR                        ;Divide by Four.                               ;2
       LSR                        ;                                              ;2
       BNE    NoiseSave           ;Always branch                                 ;2
;Noise 2 : Man Eaten
EatenNoise:
       LDA    NoteCnt             ;                                              ;3
       LSR                        ;                                              ;2
       ADC    #$08                ;                                              ;2
       TAY                        ;      the Volume.                             ;2
       LDA    NoteCnt             ;                                              ;3
       EOR    #$0F                ;                                              ;2
       BNE    NoiseSaveX          ;Always branch                                 ;2
;Noise 3 : Dyning Dragon
DragDieNoise:
       LDA    NoteCnt             ;Put the Note Count In                         ;3
       TAY                        ;      the Volume.                             ;2
       EOR    #$1F                ;                                              ;2
       LDX    #$04                ;Set the Audio Control                         ;2
       BNE    NoiseSave           ;Always branch                                 ;2
;Noise 4 : Dropping Object.
NoiseDropObject:
       LDA    NoteCnt             ;Get Not Count                                 ;3
       EOR    #$03                ;Reverse it as noise does up.                  ;2
       .byte $2C
;Noise 5 : Picking up an Object.
NoiseGetObject:
       LDA    NoteCnt             ;Get Not Count.                                ;3
       LDY    #$05                ;                                              ;2
NoiseSaveX:
       LDX    #$06                ;                                              ;2
NoiseSave:
       STA    AUDF0               ;Store in Frequency for Channel 00.            ;3
       STX    AUDC0               ;Set a Noise on Channel 00.                    ;3
NoiseSaveVolume:
       STY    AUDV0               ;Set Volume on Channel 00.                     ;3
       RTS                        ;                                              ;6


;       ORG $F87F
;       .byte $00



;memory addresses $F87F to $FA74 are completely free
;if desired, tables can be transferred here to make custom objects,
;custom states, many more rooms in the matrix, etc.


       ORG $FA78
;this address will need to be adjusted if more is added to the tables (bump it lower)



;Joystick Merge Values
ReadStick_3:
       .byte $00,$C0,$30            ;No change, No horizontal, No vertical.

;all "curr" constants put on the same byte location (all just a single $00 value)
SwordCurr:
DotCurr:
SurroundCurr:
BridgeCurr:
KeyCurr:
ChalliseCurr:
AuthorCurr:
NullCurr:
MagnetCurr:
NumberInfo:
       .byte $00,$50,$40          ;#5 Number: Room 00, (50,40)

;Object #11 : List of States
MagnetStates:
       .byte $FF,<GfxMagnet,>GfxMagnet          ;State FF at FE12


;Object #10 : List of States
ChalliseStates:
       .byte $FF,<GfxChallise,>GfxChallise          ;State FF at &FDF3


;Object #1 States (Portcullis)
PortStates:
       .byte $04,<GfxPort07,>GfxPort07          ;State 04 at FB24 -Open
       .byte $08,<GfxPort06,>GfxPort06          ;State 08 at FB22
       .byte $0C,<GfxPort05,>GfxPort05          ;State 0C at FB20
       .byte $10,<GfxPort04,>GfxPort04          ;State 10 at FB1E
       .byte $14,<GfxPort03,>GfxPort03          ;State 14 at FB1C
       .byte $18,<GfxPort02,>GfxPort02          ;State 18 at FB1A
       .byte $1C,<GfxPort01,>GfxPort01          ;State 1C at FB18 -Closed
       .byte $20,<GfxPort02,>GfxPort02          ;State 20 at FB1A
       .byte $24,<GfxPort03,>GfxPort03          ;State 24 at FB1C
       .byte $28,<GfxPort04,>GfxPort04          ;State 28 at FB1E
       .byte $2C,<GfxPort05,>GfxPort05          ;State 2C at FB20
       .byte $30,<GfxPort06,>GfxPort06          ;State 30 at FB22
       .byte $FF,<GfxPort07,>GfxPort07          ;State FF at FB24 -Open



;Object Data
;Offset 0 : Room number of object.
;Offset 1 : X Coordinate of object.
;Offset 2 : Y Coordinate of object.

;Object #1 : Portcullis
PortInfo1:
       .byte $11,$4D,$31          ;Room 11, X/Y location of gate (4D, 31)
;Object #2 : Portcullis
PortInfo2:
       .byte $0F,$4D,$31          ;Room 0F, (4D, 31)
;Object #3 : Portcullis
PortInfo3:
       .byte $10,$4D,$31          ;Room 10, (4D, 31)

;Object #1 : State List
SurroundStates:
       .byte $FF,<GfxSurround,>GfxSurround          ;State FF as FC05


;Object #0B : List of States
KeyStates:
       .byte $FF,<GfxKey,>GfxKey


;Object #0E : List of States
BatStates:
       .byte $03,<GfxBat1,>GfxBat1          ;State 03 at &FD1A
       .byte $FF,<GfxBat2,>GfxBat2          ;State FF as &FD22

;Object #6 : States
DragonStates:
       .byte $00,<GfxDrag0,>GfxDrag0          ;State 00 at &FD3A
       .byte $01,<GfxDrag2,>GfxDrag2          ;State 01 at &FD66
       .byte $02,<GfxDrag0,>GfxDrag0          ;State 02 at &FD3A
       .byte $FF,<GfxDrag1,>GfxDrag1          ;State FF at &FD4F

;Object #4 : States
AuthorStates:
       .byte $FF,<GfxAuthor,>GfxAuthor  ;State FF at &FD88

;Object #9 : List of States
SwordStates:
       .byte $FF,<GfxSword,>GfxSword          ;State FF at &FD7C

;Object #0F : List of States
DotStates:
       .byte $FF,<GfxDot,>GfxDot          ;State FF at FD86


;Object #5 States.
NumberStates:
       .byte $01,<GfxNum1,>GfxNum1          ;State 1 as FCF4
       .byte $03,<GfxNum2,>GfxNum2          ;State 3 as FD04
       .byte $FF,<GfxNum3,>GfxNum3          ;State FF as FD0C

;Bat Object Matrix.
BatMatrix:
       .byte BatR,ChaliseR          ;Bat,Chalise
       .byte BatR,SwordR            ;Bat,Sword
       .byte BatR,BridgeR           ;Bat,Bridge
       .byte BatR,YKeyR             ;Bat,Yellow Key
       .byte BatR,WKeyR             ;Bat,White Key
       .byte BatR,BKeyR             ;Bat,Black Key
       .byte BatR,RDragonR          ;Bat,Red Dragon
       .byte BatR,YDragonR          ;Bat,Yellow Dragon
       .byte BatR,GDragonR          ;Bat,Green Dragon
       .byte BatR,MagnetR           ;Bat,Magnet
       .byte $00                    ;matrix end

;Magnet Object Matrix.
MagnetMatrix:
       .byte YKeyR,MagnetR          ;Yellow Key, Magnet
       .byte WKeyR,MagnetR          ;White Key, Magnet
       .byte BKeyR,MagnetR          ;Black Key, Magnet
       .byte SwordR,MagnetR         ;Sword, Magnet
       .byte BridgeR,MagnetR        ;Bridge, Magnet
       .byte ChaliseR,MagnetR       ;Chalise, Magnet
       .byte $00                    ;matrix end


       ORG $FB00


;Object #12 : List of States
NullStates:
       .byte $FF,<GfxNull,>GfxNull



Objects:
;NOTE: SurroundData must be listed first, NullData last.
SurroundData:      ;<-these "Data" tags used up top to define "Number" constants
;Offset 0 : Low byte object information (moveable stuff)
;Offset 1 : High byte object information (moveable stuff)
;Offset 2 : Low byte to object's current state
;Offset 3 : High byte to object's current state
;Offset 4 : Low byte list of states
;Offset 5 : High byte list of states
;Offset 6 : Color (if odd, object is to Flash)
;Offset 7 : Size of object ($00 = small, $07 = large)
Store1:
       .byte <SurroundR                 ;#0 Invisible Surround Offsets
Store2:
       .byte >SurroundR                 ;1
Store3:
       .byte <SurroundCurr              ;2 Current state location
Store4:
       .byte >SurroundCurr              ;3
Store5:
       .byte <SurroundStates            ;4 list of states location
Store6:
       .byte >SurroundStates            ;5
Store7:
       .byte $28                        ;6 color (Orange)
Store8:
       .byte $07                        ;7 size (Large)

YGateData:
       .word PortInfo1,YGateR,PortStates
       .byte $00,$00 ;Yellow castle Gate #$01  Yellow, Small

WGateData:
       .word PortInfo2,WGateR,PortStates
       .byte $00,$00 ;White castle Gate  #$02  White, Small

BGateData:
       .word PortInfo3,BGateR,PortStates
       .byte $00,$00 ;Black castle Gate  #$03  Black, Small

AuthorData:
       .word AuthorInfo,AuthorCurr,AuthorStates
       .byte $CB,$00 ;Author Signature   #$04  Flash, Small

NumberData:
       .word NumberInfo,Level,NumberStates
       .byte $C8,$00 ;Number token       #$05  Green, Small

RDragonData:
       .word RDragonR,RDragonR+4,DragonStates
       .byte $36,$00 ;Red Dragon         #$06  Red, Small

YDragonData:
       .word YDragonR,YDragonR+4,DragonStates
       .byte $1A,$00 ;Yellow Dragon      #$07  Yellow, Small

GDragonData:
       .word GDragonR,GDragonR+4,DragonStates
       .byte $C8,$00 ;Green Dragon       #$08  Green, Small

SwordData:
       .word SwordR,SwordCurr,SwordStates
       .byte $1A,$00 ;Sword              #$09  Yellow, Small

BridgeData:
       .word BridgeR,BridgeCurr,BridgeStates
       .byte $66,$07 ;Bridge             #$0A  Purple, Large

YKeyData:
       .word YKeyR,KeyCurr,KeyStates
       .byte $1A,$00 ;Yellow Key         #$0B  Yellow, Small

WKeyData:
       .word WKeyR,KeyCurr,KeyStates
       .byte $0E,$00 ;White Key          #$0C  White, Small

BKeyData:
       .word BKeyR,KeyCurr,KeyStates
       .byte $00,$00 ;Black Key          #$0D  Black, Small

BatData:
       .word BatR,BatR+4,BatStates
       .byte $00,$00 ;Bat                #$0E  Black, Small

DotData:
       .word DotR,DotCurr,DotStates
       .byte $08,$00 ;Dot                #$0F  Grey, Small

ChaliseData:
       .word ChaliseR,ChalliseCurr,ChalliseStates
       .byte $CB,$00 ;Chalise            #$10  Flash, Small

MagnetData:
       .word MagnetR,MagnetCurr,MagnetStates
       .byte $00,$00 ;Magnet             #$11  Black, Small

NullData:
       .word NullR,NullCurr,NullStates
       .byte $00,$00 ;Null object        #$12  Black, Small












;Game1Objects and Game2Objects must hold the same number of bytes
;Object locations (room and coordinate) for game 01.
Game1Objects:
       .byte $15,$51,$12            ;Black dot (Room, X, Y)
       .byte $0E,$50,$20,$00,$00    ;Red Dragon (Room, X, Y, Movement, State)
       .byte $01,$50,$20,$00,$00    ;Yellow Dragon (Room, X, Y, Movement, State)
       .byte $1D,$50,$20,$00,$00    ;Green Dragon (Room, X, Y, Movement, State)
       .byte $1B,$80,$20            ;Magnet (Room,X,Y)
       .byte $12,$20,$20            ;Sword (Room,X,Y)
       .byte $1C,$30,$20            ;Challise (Room,X,Y)
       .byte $04,$29,$37            ;Bridge (Room,X,Y)
       .byte $11,$20,$40            ;Yellow Key (Room,X,Y)
       .byte $0E,$20,$40            ;White Key (Room,X,Y)
       .byte $1D,$20,$40            ;Black Key (Room,X,Y)
       .byte $1C                    ;Portcullis State
       .byte $1C                    ;Portcullis State
       .byte $1C                    ;Portcullis State
       .byte $1A,$20,$20,$00,$00    ;Bat (Room, X, Y, Movement, State)
       .byte $78,$00                ;Bat (Carrying, Fed-Up)

;Object locations (room and coordinate) for Games 02 and 03.
Game2Objects:
       .byte $15,$51,$12            ;Black Dot (Room,X,Y)
       .byte $14,$50,$20,$A0,$00    ;Red Dragon (Room,X,Y,Movement,State)
       .byte $19,$50,$20,$A0,$00    ;Yellow Dragon (Room,X,Y,Movement,State)
       .byte $04,$50,$20,$A0,$00    ;Green Dragon (Room,X,Y,Movement,State)
       .byte $0E,$80,$20            ;Magnet (Room,X,Y)
       .byte $11,$20,$20            ;Sword (Room,X,Y)
       .byte $14,$30,$20            ;Chalise (Room,X,Y)
       .byte $0B,$40,$40            ;Bridge (Room,X,Y)
       .byte $09,$20,$40            ;Yellow Key (Room,X,Y)
       .byte $06,$20,$40            ;White Key (Room,X,Y)
       .byte $19,$20,$40            ;Black Key (Room,X,Y)
       .byte $1C                    ;Portcullis State
       .byte $1C                    ;Portcullis State
       .byte $1C                    ;Portcullis State
       .byte $02,$20,$20,$90,$00    ;Bat (Room,X,Y,Movement,State)
       .byte $78,$00                ;Bat (Carrying, Fed-Up)

;Object #0A : List of States
BridgeStates:
       .byte $FF,<GfxBridge,>GfxBridge          ;State FF at &FCDB


       ORG $FC00


;Dragon Difficulty
DragonDiff:
       .byte $D0,$E8                  ;Level 1 : Am, Pro
       .byte $F0,$F6                  ;Level 2 : Am, Pro
       .byte $F0,$F6                  ;Level 3 : Am, Pro

;Room differences for different levels (level 1,2,3)
RoomDiffs:
RD1:   ;<- These "RD" tags used in the room matrix...subtract RD0 to get proper $80 value
       .byte $10,$0F,$0F            ;Down from Room 01
RD2:
       .byte $05,$11,$11            ;Down from Room 02
RD3:
       .byte $1D,$0A,$0A            ;Down from Room 03
RD4:
       .byte $1C,$16,$16            ;U/L/R/D from Room 1B (Black Castle Room)
RD5:
       .byte $1B,$0C,$0C            ;Down from Room 1C
RD6:
       .byte $03,$0C,$0C            ;Up from Room 1D (Top Entry Room)

;Room Bounds Data.
;Ex. the chalise at location &B9 can only
;     exist in rooms 13-1A for level 3.
Loc_1:
       .byte ChaliseR               ;
Loc_2:
       .byte $13                    ;Chalise
Loc_3:
       .byte $1A                    ;
       .byte RDragonR,$01,$1D       ;Red Dragon
       .byte YDragonR,$01,$1D       ;Yellow Dragon
       .byte GDragonR,$01,$1D       ;Green Dragon
       .byte SwordR,$01,$1D         ;Sword
       .byte BridgeR,$01,$1D        ;Bridge
       .byte YKeyR,$01,$1D          ;Yellow Key
       .byte WKeyR,$01,$16          ;White Key
       .byte BKeyR,$01,$12          ;Black Key
       .byte BatR,$01,$1D           ;Bat
       .byte MagnetR,$01,$1D        ;Magnet
Loc_4:
       .byte <Game1Objects                    ;objects game 01.
Loc_5:
       .byte >Game1Objects                    ;      --continued.
       .byte <Game2Objects,>Game2Objects      ;objects game 02.
       .byte <Game2Objects,>Game2Objects      ;objects game 03.



;Portcullis #1, #2, #3
PortOffsets:
     .byte YGateNumber,WGateNumber,BGateNumber

;Keys #1, #2, #3  (Yellow, White, Black)
KeyOffsets:
     .byte YKeyNumber,WKeyNumber,BKeyNumber

;Castle Entry Rooms (Yellow, White, Black)...the first screen inside the castle
EntryRoomOffsets:
     .byte $12,$1A,$1B

;Castle Rooms (Yellow, White, Black)...the screen of the castle itself
CastleRoomOffsets:
     .byte $11,$0F,$10




;Room Data
;Offset 0 : Low byte foom graphics data.
;Offset 1 : High byte room graphics data
;Offset 2 : Color...if $08, invisible surround present...if an odd number, room is to Flash

;Offset 3 : Bits 5-0 : Playfield Control
;          Bit 0 (+$01): True if room data to be displayed reverse (R), false if mirrored (M)
;          Bit 2 (+$04): True if room is "dark"
;          Bit 5 (+$20): All rooms
;          Bit 6 (+$40): True if right thin wall wanted.
;          Bit 7 (+$80): True if left thin wall wanted.

;Offset 4 : Room Above
;Offset 5 : Room Right
;Offset 6 : Room Down
;Offset 7 : Room Left
;all room numbers must be listed consecutively
RoomDataTable:
       .byte <Room00,>Room00,$66,$21,$00,$00,$00,$00                ;Number room
       .byte <Room01,>Room01,$D8,$A1,$08,$02,RD1-RD0,$03            ;Below blue maze
       .byte <Room02,>Room02,$C8,$21,$11,$03,RD2-RD0,$01            ;Below Yellow Castle
       .byte <Room03,>Room03,$E8,$61,$06,$01,RD3-RD0,$02            ;Above the catacombs
       .byte <Room04,>Room04,$86,$21,$10,$05,$07,$06                ;Blue maze,below black cast
       .byte <Room05,>Room05,$86,$21,$1D,$06,$08,$04                ;Blue maze,above entry
       .byte <Room06,>Room06,$86,$21,$07,$04,$03,$05                ;Blue maze bottom
       .byte <Room07,>Room07,$86,$21,$04,$08,$06,$08                ;Blue maze center
       .byte <Room08,>Room08,$86,$21,$05,$07,$01,$07                ;Blue maze entry
       .byte <Room09,>Room09,$08,$25,$0A,$0A,$0B,$0A                ;Catacombs middle
       .byte <Room0A,>Room0A,$08,$25,$03,$09,$09,$09                ;Catacombs entry
       .byte <Room0B,>Room0B,$08,$25,$09,$0C,$1C,$0D                ;Catacombs side
       .byte <Room0C,>Room0C,$98,$61,$1C,$0D,$1D,$0B                ;Rcorridor, right of cat
       .byte <Room0D,>Room0D,$B8,$A1,$0F,$0B,$0E,$0C                ;Lcorridor,below Wh. Castle
       .byte <Room0E,>Room0E,$A8,$21,$0D,$10,$0F,$10                ;Below Lcorridor (below wt)
       .byte <Room0F,>Room0F,$0C,$21,$0E,$0F,$0D,$0F                ;White Castle (outside)
       .byte <Room10,>Room10,$00,$21,$01,$1C,$04,$1C                ;Black Castle (outside)
       .byte <Room11,>Room11,$1A,$21,$06,$03,$02,$01                ;Yellow Castle (outside)
       .byte <Room12,>Room12,$1A,$21,$12,$12,$12,$12                ;Inside yellow castle
       .byte <Room13,>Room13,$08,$25,$15,$14,$15,$16                ;Black maze,right of entry
       .byte <Room14,>Room14,$08,$24,$16,$15,$16,$13                ;Black maze, Chalise room
       .byte <Room15,>Room15,$08,$24,$13,$16,$13,$14                ;Black maze, Dot's room
       .byte <Room16,>Room16,$08,$25,$14,$13,$1B,$15                ;Black maze entry
       .byte <Room17,>Room17,$36,$21,$19,$18,$19,$18                ;Red maze,above black key
       .byte <Room18,>Room18,$36,$21,$1A,$17,$1A,$17                ;Red maze,above entry
       .byte <Room19,>Room19,$36,$21,$17,$1A,$17,$1A                ;Red maze,black key room
       .byte <Room1A,>Room1A,$36,$21,$18,$19,$18,$19                ;Red maze entry
       .byte <Room1B,>Room1B,$36,$21,RD4-RD0,RD4-RD0,RD4-RD0,RD4-RD0;Just inside black castle
       .byte <Room1C,>Room1C,$66,$21,$1D,$07,RD5-RD0,$08            ;Above Rcorridor,right/cat
       .byte <Room1D,>Room1D,$36,$21,RD6-RD0,$01,$10,$03            ;Under Rcorridor,right/cat
       .byte <Room1E,>Room1E,$66,$21,$06,$01,$06,$03                ;Warren Robinett's room


;all must be on 1 page
;if an object is listed befor the dragon, it is "feared"
;if an object is listed after the dragon, it is "guarded"
;extra bytes can be used to add more objects to guard or fear...be sure to end with $00
;Red Dragon Object Matrix
RedDragMatrix:
       .byte SwordR,RDragonR        ;Sword, Red Dragon
       .byte RDragonR,PlayerRoom    ;Red Dragon, Ball
       .byte RDragonR,ChaliseR      ;Red Dragon, Chalise
       .byte RDragonR,WKeyR         ;Red Dragon, White Key
       .byte $00                    ;matrix end

;Yellow Dragon's Object Matrix
YelDragMatrix:
       .byte SwordR,YDragonR        ;Sword, Yellow Dragon
       .byte YKeyR,YDragonR         ;Yellow Key, Yellow Dragon
       .byte YDragonR,PlayerRoom    ;Yellow Dragon, Ball
       .byte YDragonR,ChaliseR      ;Yellow Dragon, Chalise
       .byte $00                    ;matrix end

;Green Dragon's Object Matrix
GreenDragonMatrix:
       .byte SwordR,GDragonR        ;Sword, Green Dragon
       .byte GDragonR,PlayerRoom    ;Green Dragon, Ball
       .byte GDragonR,ChaliseR      ;Green Dragon Chalise
       .byte GDragonR,BridgeR       ;Green Dragon, Bridge
       .byte GDragonR,MagnetR       ;Green Dragon, Magnet
       .byte GDragonR,BKeyR         ;Green Dragon, Black Key
       .byte $00                    ;matrix end

;Object #5 State #1 Graphic :'1'
GfxNum1:
       .byte $04                  ; X
       .byte $0C                  ;XX
       .byte $04                  ; X
       .byte $04                  ; X
       .byte $04                  ; X
       .byte $04                  ; X
       .byte $0E                  ;XXX
       .byte $00                  ;bitmap end

;Object #0E : State 03 : Graphic
GfxBat1:
       .byte $81                  ;X      X
       .byte $81                  ;X      X
       .byte $C3                  ;XX    XX
       .byte $C3                  ;XX    XX
       .byte $FF                  ;XXXXXXXX
       .byte $5A                  ; X XX X
       .byte $66                  ; XX  XX
       .byte $00                  ;bitmap end

;Object #0E : State FF : Graphic
GfxBat2:
       .byte $01                  ;       X
       .byte $80                  ;X
       .byte $01                  ;       X
       .byte $80                  ;X
       .byte $3C                  ;  XXXX
       .byte $5A                  ; X XX X
       .byte $66                  ; XX  XX
       .byte $C3                  ;XX    XX
       .byte $81                  ;X      X
       .byte $81                  ;X      X
       .byte $81                  ;X      X
       .byte $00                  ;bitmap end

;Object #11 : State FF : Graphic
GfxMagnet:
       .byte $3C                  ;  XXXX
       .byte $7E                  ; XXXXXX
       .byte $E7                  ;XXX  XXX
       .byte $C3                  ;XX    XX
       .byte $C3                  ;XX    XX
       .byte $C3                  ;XX    XX
       .byte $C3                  ;XX    XX
       .byte $C3                  ;XX    XX
       .byte $00                  ;bitmap end

;Object #4 : State FF : Graphic
GfxAuthor:
;Object #10 : State FF : Graphic
GfxChallise:
       .byte $81                  ;X      X
       .byte $81                  ;X      X
       .byte $C3                  ;XX    XX
       .byte $7E                  ; XXXXXX
       .byte $7E                  ; XXXXXX
       .byte $3C                  ;  XXXX
       .byte $18                  ;   XX
       .byte $18                  ;   XX
       .byte $7E                  ; XXXXXX
       .byte $00                  ;bitmap end





;White Castle (outside)
Room0F:
;Black Castle (outside)
Room10:
;Yellow Castle (outside)
Room11:
       .byte $F0,$FE,$15          ;XXXXXXXXXXX X X X      R R R RRRRRRRRRRR
       .byte $30,$03,$1F          ;XX        XXXXXXX      RRRRRRR        RR
       .byte $30,$03,$FF          ;XX        XXXXXXXXXXRRRRRRRRRR        RR
       .byte $30,$00,$FF          ;XX          XXXXXXXXRRRRRRRR          RR
       .byte $30,$00,$3F          ;XX          XXXXXX    RRRRRR          RR
       .byte $30,$00,$00          ;XX                                    RR
;Catacombs Entry
Room0A:
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR (line shared)
       .byte $00,$30,$00          ;      XX                        RR      
       .byte $F0,$30,$FF          ;XXXX  XX    XXXXXXXXRRRRRRRRR   RR  RRRR
       .byte $00,$30,$C0          ;      XX          XXRR          RR      
       .byte $F0,$F3,$C0          ;XXXXXXXX  XX      XXRR      RR  RRRRRRRR
       .byte $00,$03,$C0          ;          XX      XXRR      RR          
;Catacombs Middle
Room09:
       .byte $F0,$FF,$CC          ;XXXXXXXXXXXX  XX  XXRR  RR  RRRRRRRRRRRR (top line shared)
       .byte $00,$00,$CC          ;              XX  XXRR  RR              
       .byte $F0,$03,$CF          ;XXXX      XXXXXX  XXRR  RRRRRR      RRRR
       .byte $00,$03,$00          ;          XX                RR          
       .byte $F0,$F3,$FC          ;XXXXXXXX  XX  XXXXXXRRRRRR  RR  RRRRRRRR
       .byte $00,$33,$0C          ;      XX  XX  XX        RR  RR  RR      
;Catacombs Side
Room0B:
       .byte $F0,$33,$CC          ;XXXX  XX  XX  XX  XXRR  RR  RR  RR  RRRR (top line shared)
       .byte $00,$30,$CC          ;      XX      XX  XXRR  RR      RR      
       .byte $00,$3F,$CF          ;      XXXXXX  XX  XXRR  RR  RRRRRR      
       .byte $00,$00,$C0          ;                  XXRR                  
       .byte $00,$3F,$C3          ;      XXXXXXXX    XXRR    RRRRRRRR      
       .byte $00,$30,$C0          ;      XX          XXRR          RR      
;Black Maze, Chalise room
Room14:
       .byte $F0,$FF,$FF          ;XXXXXXXXXXXXXXXXXXXXMMMMMMMMMMMMMMMMMMMM (top line shared)
       .byte $00,$00,$C0          ;                  XX                  MM
       .byte $F0,$FF,$CF          ;XXXXXXXXXXXXXXXX  XXMMMMMMMMMMMMMMMM  MM
       .byte $00,$00,$0C          ;                  XX                  MM
       .byte $F0,$0F,$FF          ;XXXX    XXXXXXXXXXXXMMMM    MMMMMMMMMMMM
       .byte $00,$0F,$C0          ;        XXXX      XX        MMMM      MM
;Black Maze Entry
Room16:
       .byte $30,$CF,$CC          ;XX  XX  XXXX  XX  XXRR  RR  RRRR  RR  RR (top line shared)
       .byte $00,$C0,$CC          ;    XX        XX  XXRR  RR        RR    
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR
       .byte $00,$00,$00          ;                                        
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR
       .byte $00,$00,$00          ;                                        
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR


       ORG $FE00


;Inside Yellow castle
Room12:
;Number Room Definition
Room00:
       .byte $F0,$FF,$FF          ;XXXXXXXXXXXXXXXXXXXXRRRRRRRRRRRRRRRRRRRR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
;Right corridor, right of catacombs
Room0C:
;Left corridor, below white castle
Room0D:
       .byte $F0,$FF,$0F          ;XX|XXXXXXXXXXXXX        RRRRRRRRRRRRRRRR (top line shared)
       .byte $00,$00,$00          ;  |                                     
       .byte $00,$00,$00          ;  |                                     
       .byte $00,$00,$00          ;  |                                     
       .byte $00,$00,$00          ;  |                                     
       .byte $00,$00,$00          ;  |                                     
;Below blue maze
Room01:
;Below Yellow Castle
Room02:
;Warren Robinett's room
Room1E:
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR (top line shared)
       .byte $00,$00,$00          ;                                        
       .byte $00,$00,$00          ;                                        
       .byte $00,$00,$00          ;                                        
       .byte $00,$00,$00          ;                                        
       .byte $00,$00,$00          ;                                        
;Above the catacombs
Room03:
       .byte $F0,$FF,$FF          ;XXXXXXXXXXXXXXXXXXXXRRRRRRRRRRRRRRRRR|RR (top line shared)
       .byte $00,$00,$00          ;                                     |  
       .byte $00,$00,$00          ;                                     |  
       .byte $00,$00,$00          ;                                     |  
       .byte $00,$00,$00          ;                                     |  
       .byte $00,$00,$00          ;                                     |  
;Blue Maze, below black castle
Room04:
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR (top line shared)
       .byte $00,$0C,$0C          ;        XX    XX        RR    RR        
       .byte $F0,$0C,$3C          ;XXXX    XX    XXXX    RRRR    RR    RRRR
       .byte $F0,$0C,$00          ;XXXX    XX                    RR    RRRR
       .byte $F0,$FF,$3F          ;XXXXXXXXXXXXXXXXXX    RRRRRRRRRRRRRRRRRR
       .byte $00,$30,$30          ;      XX        XX    RR        RR      
;Center of Blue Maze
Room07:
       .byte $F0,$33,$3F          ;XXXX  XX  XXXXXXXX    RRRRRRRR  RR  RRRR (top line shared)
       .byte $00,$30,$3C          ;      XX      XXXX    RRRR      RR      
       .byte $F0,$FF,$3C          ;XXXXXXXXXXXX  XXXX    RRRR  RRRRRRRRRRRR
       .byte $00,$03,$3C          ;          XX  XXXX    RRRR  RR          
       .byte $F0,$33,$3C          ;XXXX  XX  XX  XXXX    RRRR  RR  RR  RRRR
       .byte $00,$33,$0C          ;      XX  XX  XX        RR  RR  RR      
;Bottom of Blue Maze
Room06:
       .byte $F0,$F3,$0C          ;XXXXXXXX  XX  XX        RR  RR  RRRRRRRR (top line shared)
       .byte $00,$30,$0C          ;      XX      XX        RR      RR      
       .byte $F0,$3F,$0F          ;XXXX  XXXXXXXXXX        RRRRRRRRRR  RRRR
       .byte $F0,$00,$00          ;XXXX                                RRRR
       .byte $F0,$F0,$00          ;XXXXXXXX                        RRRRRRRR
       .byte $00,$30,$00          ;      XX                        RR      
;Blue Maze,above entry
Room05:
       .byte $F0,$FF,$FF          ;XXXXXXXXXXXXXXXXXXXXRRRRRRRRRRRRRRRRRRRR (top line shared)
       .byte $00,$00,$00          ;                                        
       .byte $F0,$FC,$FF          ;XXXXXXXXXX  XXXXXXXXRRRRRRRR  RRRRRRRRRR
       .byte $F0,$00,$C0          ;XXXX              XXRR              RRRR
       .byte $F0,$3F,$CF          ;XXXX  XXXXXXXXXX  XXRR  RRRRRRRRRR  RRRR
       .byte $00,$30,$CC          ;      XX      XX  XXRR  RR      RR      
;Blue Maze Entry
Room08:
       .byte $F0,$F3,$CC          ;XXXXXXXX  XX  XX  XXRR  RR  RR  RRRRRRRR (top line shared)
       .byte $00,$33,$0C          ;      XX  XX  XX        RR  RR  RR      
       .byte $F0,$33,$FC          ;XXXX  XX  XX  XXXXXXRRRRRR  RR  RR  RRRR
       .byte $00,$33,$00          ;      XX  XX                RR  RR      
       .byte $F0,$F3,$FF          ;XXXXXXXX  XXXXXXXXXXRRRRRRRRRR  RRRRRRRR
       .byte $00,$00,$00          ;                                        
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR

;Black Maze, right from entry
Room13:
       .byte $F0,$F0,$FF          ;XXXXXXXX    XXXXXXXXRRRRRRRR    RRRRRRRR
       .byte $00,$00,$03          ;            XX            RR            
       .byte $F0,$FF,$03          ;XXXXXXXXXXXXXX            RRRRRRRRRRRRRR
       .byte $00,$00,$00          ;                                        
       .byte $30,$3F,$FF          ;XX    XXXXXXXXXXXXXXRRRRRRRRRRRRRR    RR
       .byte $00,$30,$00          ;      XX                        RR      
;Black Maze, Dot's room
Room15:
       .byte $F0,$F0,$FF          ;XXXXXXXX    XXXXXXXXMMMMMMMM    MMMMMMMM (top line shared)
       .byte $30,$00,$00          ;XX                  MM                  
       .byte $30,$3F,$FF          ;XX    XXXXXXXXXXXXXXMM    MMMMMMMMMMMMMM
       .byte $00,$30,$00          ;      XX                  MM            
       .byte $F0,$F0,$FF          ;XXXXXXXX    XXXXXXXXMMMMMMMM    MMMMMMMM
       .byte $30,$00,$03          ;XX          XX     .MM          MM      
       .byte $F0,$F0,$FF          ;XXXXXXXX    XXXXXXXXMMMMMMMM    MMMMMMMM


;Object #0A : State FF : Graphic
GfxBridge:
       .byte $C3                  ;XX    XX
       .byte $C3                  ;XX    XX
       .byte $C3                  ;XX    XX
       .byte $C3                  ;XX    XX
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $42                  ; X    X
       .byte $C3                  ;XX    XX
       .byte $C3                  ;XX    XX
       .byte $C3                  ;XX    XX
       .byte $C3                  ;XX    XX
       .byte $00                  ;bitmap end

;Object #9 : State FF : Graphics
GfxSword:
       .byte $20                  ;  X
       .byte $40                  ; X
       .byte $FF                  ;XXXXXXXX
       .byte $40                  ; X
       .byte $20                  ;  X
       .byte $00                  ;bitmap end

;Object #1 States 940FF (Graphic)
GfxPort01:
       .byte $FE                  ;XXXXXXX
       .byte $AA                  ;X X X X
GfxPort02:
       .byte $FE                  ;XXXXXXX
       .byte $AA                  ;X X X X
GfxPort03:
       .byte $FE                  ;XXXXXXX
       .byte $AA                  ;X X X X
GfxPort04:
       .byte $FE                  ;XXXXXXX
       .byte $AA                  ;X X X X
GfxPort05:
       .byte $FE                  ;XXXXXXX
       .byte $AA                  ;X X X X
GfxPort06:
       .byte $FE                  ;XXXXXXX
       .byte $AA                  ;X X X X
GfxPort07:
       .byte $FE                  ;XXXXXXX
       .byte $AA                  ;X X X X
GfxPort08:
       .byte $FE                  ;XXXXXXX
       .byte $AA                  ;X X X X
GfxPort09:
GfxNull:
       .byte $00                  ;bitmap end

;Object #0B : State FF : Graphic
GfxKey:
       .byte $07                  ;     XXX
       .byte $FD                  ;XXXXXX X
       .byte $A7                  ;X X  XXX
       .byte $00                  ;bitmap end


       ORG $FF00


;Object #5 State #2 Grphic : '2'
GfxNum2:
       .byte $0E                  ; XXX
       .byte $11                  ;X   X
       .byte $01                  ;    X
       .byte $02                  ;   X
       .byte $04                  ;  X
       .byte $08                  ; X
       .byte $1F                  ;XXXXX
       .byte $00                  ;bitmap end

;Object #5 State #3 Graphic :'3'
GfxNum3:
       .byte $0E                  ; XXX
       .byte $11                  ;X   X
       .byte $01                  ;    X
       .byte $06                  ;  XX
       .byte $01                  ;    X
       .byte $11                  ;X   X
       .byte $0E                  ; XXX
       .byte $00                  ;bitmap end

;Object #1 : Graphic
GfxSurround:
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $FF                  ;XXXXXXXX
       .byte $00                  ;bitmap end

;Object #6 : State #00 : Graphic
GfxDrag0:
       .byte $06                  ;     XX
       .byte $0F                  ;    XXXX
       .byte $F3                  ;XXXX  XX
       .byte $FE                  ;XXXXXXX
       .byte $0E                  ;    XXX
       .byte $04                  ;     X
       .byte $04                  ;     X
       .byte $1E                  ;   XXXX
       .byte $3F                  ;  XXXXXX
       .byte $7F                  ; XXXXXXX
       .byte $E3                  ;XXX   XX
       .byte $C3                  ;XX    XX
       .byte $C3                  ;XX    XX
       .byte $C7                  ;XX   XXX
       .byte $FF                  ;XXXXXXXX
       .byte $3C                  ;  XXXX
       .byte $08                  ;    X
       .byte $8F                  ;X   XXXX
       .byte $E1                  ;XXX    X
       .byte $3F                  ;  XXXXXX
       .byte $00                  ;bitmap end

;Object 6 : State FF : Graphic
GfxDrag1:
       .byte $80                  ;X
       .byte $40                  ; X
       .byte $26                  ;  X  XX
       .byte $1F                  ;   XXXXX
       .byte $0B                  ;    X XX
       .byte $0E                  ;    XXX
       .byte $1E                  ;   XXXX
       .byte $24                  ;  X  X
       .byte $44                  ; X   X
       .byte $8E                  ;X   XXX
       .byte $1E                  ;   XXXX
       .byte $3F                  ;  XXXXXX
       .byte $7F                  ; XXXXXXX
       .byte $7F                  ; XXXXXXX
       .byte $7F                  ; XXXXXXX
       .byte $7F                  ; XXXXXXX
       .byte $3E                  ;  XXXXX
       .byte $1C                  ;   XXX
       .byte $08                  ;    X
       .byte $F8                  ;XXXXX
       .byte $80                  ;X
       .byte $E0                  ;XXX
       .byte $00                  ;bitmap end

;Object 6 : State 02 : Graphic
GfxDrag2:
       .byte $0C                  ;    XX
       .byte $0C                  ;    XX
       .byte $0C                  ;    XX
       .byte $0E                  ;    XXX
       .byte $1B                  ;   XX X
       .byte $7F                  ; XXXXXXX
       .byte $CE                  ;XX  XXX
       .byte $80                  ;X
       .byte $FC                  ;XXXXXX
       .byte $FE                  ;XXXXXXX
       .byte $FE                  ;XXXXXXX
       .byte $7E                  ; XXXXXX
       .byte $78                  ; XXXX
       .byte $20                  ;  X
       .byte $6E                  ; XX XXX
       .byte $42                  ; X    X
       .byte $7E                  ; XXXXXX
       .byte $00                  ;bitmap end


;Red Maze, above entry
Room18:
       .byte $F0,$FF,$FF          ;XXXXXXXXXXXXXXXXXXXXRRRRRRRRRRRRRRRRRRRR
       .byte $00,$00,$C0          ;                  XXRR                  
       .byte $F0,$FF,$CF          ;XXXXXXXXXXXXXXXX  XXRR  RRRRRRRRRRRRRRRR
       .byte $00,$00,$CC          ;              XX  XXRR  RR              
       .byte $F0,$33,$FF          ;XXXX  XX  XXXXXXXXXXRRRRRRRRRR  RR  RRRR
       .byte $F0,$33,$00          ;XXXX  XX  XX                RR  RR  RRRR
;Red Maze Entry
Room1A:
       .byte $F0,$3F,$0C          ;XXXX  XXXXXX  XX        RR  RRRRRR  RRRR (top line shared)
       .byte $F0,$00,$0C          ;XXXX          XX        RR          RRRR
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR
       .byte $00,$30,$00          ;      XX                        RR      
       .byte $F0,$30,$00          ;XXXX  XX                        RR  RRRR
       .byte $00,$30,$00          ;      XX                        RR      
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR

;Above right corridor (right of catacombs in games 2/3, 2nd room inside black castle in game 1)
Room1C:
       .byte $F0,$FF,$FF          ;XXXXXXXXXXXXXXXXXXXXRRRRRRRRRRRRRRRRRRRR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
;Just inside the black castle
Room1B:
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR (top line shared)
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
;Below left corridor (2 screens below white castle)
Room0E:
;Below right corridor (right of catacombs in games 2/3, below right panel room in game 1)
Room1D:
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR (top line shared)
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
       .byte $30,$00,$00          ;XX                                    RR
;Red Maze, above black key's room
Room17:
       .byte $F0,$FF,$FF          ;XXXXXXXXXXXXXXXXXXXXRRRRRRRRRRRRRRRRRRRR (top line shared)
       .byte $00,$00,$00          ;                                        
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR
       .byte $00,$00,$0C          ;              XX        RR              
       .byte $F0,$FF,$0C          ;XXXXXXXXXXXX  XX        RR  RRRRRRRRRRRR
       .byte $F0,$03,$CC          ;XXXX      XX  XX  XXRR  RR  RR      RRRR
;Red Maze, black key's room
Room19:
       .byte $F0,$33,$CF          ;XXXX  XX  XXXXXX  XXRR  RRRRRR  RR  RRRR (top line shared)
       .byte $F0,$30,$00          ;XXXX  XX                        RR  RRRR
       .byte $F0,$33,$FF          ;XXXX  XX  XXXXXXXXXXRRRRRRRRRR  RR  RRRR
       .byte $00,$33,$00          ;      XX  XX                RR  RR  RRRR
       .byte $F0,$FF,$00          ;XXXXXXXXXXXX                RRRRRRRRRRRR
       .byte $00,$00,$00          ;                                        
       .byte $F0,$FF,$0F          ;XXXXXXXXXXXXXXXX        RRRRRRRRRRRRRRRR

;Object $4 : Author's Name
AuthorInfo:
       .byte $1E,$50,$69          ;Room 1E, (50, 69)

;Object #0F : State FF : Graphic
GfxDot:
       .byte $80                  ;X
       .byte $00                  ;bitmap end


       ORG $FFF8


;do not use $fff8/$fff9...bankswitch rom locations
        .word $FFFF,$F000,StartGame,$F000
